clear all;

addpath(strcat(pwd(), '\Parameters'));
addpath(strcat(pwd(), '\Trajectory'));
addpath(strcat(pwd(), '\SystemWithLoad'));
addpath(strcat(pwd(), '\SystemWithoutLoad'));
addpath(strcat(pwd(), '\ControlTransverseLinearization'));

init_parameters;
init_trajectory;


fprintf('Starting simulation\r')
x0 = [1,0,0,0,0];
[t1, y1] = ode45(@fct_tv_control, [Theta(0),Theta(15)], x0);
fprintf('20%% complete\r')
x0 = [0,1,0,0,0];
[t2, y2] = ode45(@fct_tv_control, [Theta(0),Theta(15)], x0);
fprintf('42%% complete\r')
x0 = [0,0,1,0,0];
[t3, y3] = ode45(@fct_tv_control, [Theta(0),Theta(15)], x0);
fprintf('60%% complete\r')
x0 = [0,0,0,1,0];
[t4, y4] = ode45(@fct_tv_control, [Theta(0),Theta(15)], x0);
fprintf('80%% complete\r')
x0 = [0,0,0,0,1];
[t5, y5] = ode45(@fct_tv_control, [Theta(0),Theta(15)], x0);
fprintf('Done\r')

H = gcf;
clf(H);
set(H, 'name', 'Transverse Linearization');

subplot(3,2,1);
plot(t1,y1(:,1), 'r');hold on;
plot(t1,y1(:,2), 'g');
plot(t1,y1(:,3), 'b');
plot(t1,y1(:,4), 'm');
plot(t1,y1(:,5), 'c');
legend('I', 'y1','y2','Dy1','Dy2');
axis([0 Theta(15) -1 1.5]);
subplot(3,2,2);
plot(t2,y2(:,1), 'r');hold on;
plot(t2,y2(:,2), 'g');
plot(t2,y2(:,3), 'b');
plot(t2,y2(:,4), 'm');
plot(t2,y2(:,5), 'c');
legend('I', 'y1','y2','Dy1','Dy2');
axis([0 Theta(15) -1 1.5]);
subplot(3,2,3);
plot(t3,y3(:,1), 'r');hold on;
plot(t3,y3(:,2), 'g');
plot(t3,y3(:,3), 'b');
plot(t3,y3(:,4), 'm');
plot(t3,y3(:,5), 'c');
legend('I', 'y1','y2','Dy1','Dy2');
axis([0 Theta(15) -1 1.5]);
subplot(3,2,4);
plot(t4,y4(:,1), 'r');hold on;
plot(t4,y4(:,2), 'g');
plot(t4,y4(:,3), 'b');
plot(t4,y4(:,4), 'm');
plot(t4,y4(:,5), 'c');
legend('I', 'y1','y2','Dy1','Dy2');
axis([0 Theta(15) -1 1.5]);
subplot(3,2,5);
plot(t5,y5(:,1), 'r');hold on;
plot(t5,y5(:,2), 'g');
plot(t5,y5(:,3), 'b');
plot(t5,y5(:,4), 'm');
plot(t5,y5(:,5), 'c');
legend('I', 'y1','y2','Dy1','Dy2');
axis([0 Theta(15) -1 1.5]);


clear A
for i = 1:100; A(i,:,:) = SystemWithoutLoadAaux((i-1)/100*Theta(15));end
figure(232);
hold on
t = linspace(0,Theta(15),100);
for i = 1:5
for j = 1:5
plot(t,A(:,i,j))
end
end