% Pass Q and R as global variables
function [pp] = SolveRiccati1(endTime, startTime, F)
    [t,R] = ode45(@Riccati1,endTime:-0.001:startTime,F);
    fprintf('\n');
    pp = interp1(t, R, 'pchip', 'pp');
end

% Pass Q and R as global variables
function dS = Riccati1(t, S)
    persistent FIRST_RUN
    if isempty(FIRST_RUN)
        FIRST_RUN = 1;
        fprintf('\nTime: %*f',10,t);
    else
        fprintf('\b\b\b\b\b\b\b\b\b\b%*f',10,t);
    end
    
    global Q R
    S = reshape(S,5,5);
    
    At = Aaux_r1(t);
    Bt = Baux_r1(t);
    
    dS = (-S*At-At'*S-Q+S*Bt*inv(R)*Bt'*S);
    dS = reshape(dS,5*5,1);
end