function dx = fct_circle2(t,x)
    % Valid from 5/4*pi to 7/4*pi
    th = invphi3(x(3),2);
% 
%     persistent FIRST_RUN
%     if isempty(FIRST_RUN)
%         FIRST_RUN = 1;
%         fprintf('Time:\t theta:');
%     else
%         fprintf('%f\t%f\n',t,th);
%     end    
    
    y = ChangeVariables3(x,th);
    
    v = fct_tl_control(th, y);
    
    u = feedbacktransformation(x, v, th);

    dx = fct_without_load_sys(x,u);
end

function v = fct_tl_control(th, y)
    global Q2 R2 F2
    persistent S2
    if isempty(S2)
        global Q R
        Q = Q2;
        R = R2;
        
        S2 = SolveRiccati3(5*pi/4+0.4, 3*pi/4-0.4, F2);
    end
    B = Baux_r3(th);
    Ss = reshape(ppval(S2, th),5,5);
    L = R2\B'*Ss;
    v = L*y;
end