function dx = fct_circle3(t,x)
    % Valid from 5/4*pi to 7/4*pi
    th = invphi1(x(1),2);
 
    y = ChangeVariables1(x,th);
    
    v = fct_tl_control(th, y);
    
    u = feedbacktransformation(x, v, th);

    dx = fct_without_load_sys(x,u);
end

function v = fct_tl_control(th, y)
    global Q3 R3 F3
    persistent S3
    if isempty(S3)
        global Q R
        Q = Q3;
        R = R3;
        
        S3 = SolveRiccati1(7*pi/4+0.2, 5*pi/4-0.2, F3);
    end
    B = Baux_r1(th);
    Ss = reshape(ppval(S3, th),5,5);
    L = R3\B'*Ss;
    v = L*y;
end