function dx = fct_circle4(t,x)
    % Valid from 5/4*pi to 7/4*pi
    th = invphi3(x(3),3);
     fprintf('Theta4: %f\n', th)
    y = ChangeVariables3(x,th);
    
    v = fct_tl_control(th, y);
    
    u = feedbacktransformation(x, v, th);

    dx = fct_without_load_sys(x,u);
end

function v = fct_tl_control(th, y)
    global Q4 R4 F4
    persistent S4
    if isempty(S4)
        global Q R
        Q = Q4;
        R = R4;
        
        S4 = SolveRiccati3(9*pi/4+0.5, 7*pi/4-0.5, F4);
    end
    B = Baux_r3(th);
    if th < 1/4*pi
        th = th + 2*pi;
    end
    Ss = reshape(ppval(S4, th),5,5);
    L = R4\B'*Ss;
    v = L*y;
end