function [theta_s, Psi1_s, Psi2_s] = fct_integral_terms(theta_start,theta,samples)
% Compute terms of the integral as list for the interval [theta_start, theta]
% Matlab code: (c) Uwe Mettin, 2009 (based on Ians code)

theta_0 = theta_start;
theta_T = theta;

% sample theta
% samples = 100;
% sampling = (theta_T-theta_0)/(samples-1);
% theta_s = [theta_0:sampling:theta_T]';
theta_s = linspace(theta_0,theta_T,samples)';

% tolerance
tol = 1e-6;

warning off all
% Psi1 (first term)
Psi1_s = calc_Psi1(theta_s,tol);

% Psi2 (second term)
Psi2_s = calc_Psi2(theta_s,tol,Psi1_s);
warning on all

return

%--------------------------

function y = calc_Psi1(theta_s,tol)
y = cumquadl(@fct_calc_Psi1,theta_s,tol);
y = exp(-2*y);
return

function y = fct_calc_Psi1(theta)
% [alpha, beta, ga] = fct_albega_coeff(theta);
% y = beta ./ alpha;
y = beta2(theta) ./ alpha2(theta);
return

%--------------------------

function y = calc_Psi2(theta_s,tol,Psi1_s)
global Psi theta_Psi
Psi = Psi1_s;
theta_Psi = theta_s;
y = cumquadl(@fct_calc_Psi2,theta_s,tol);
y = 2*Psi1_s.*y;
return

function y = fct_calc_Psi2(theta)
global Psi theta_Psi
Psi_theta = interp1(theta_Psi,Psi,theta,'spline');
% [alpha, beta, ga] = fct_albega_coeff(theta);
% y = gamma ./ alpha ./ Psi_theta';
y = ga2(theta) ./ alpha2(theta) ./ Psi_theta;
return
