
function plot_control_feedback(control_feedback)
    control_feedback = sortrows(control_feedback',1)';
    [b,i,j] = unique(control_feedback(1,:));
    
    cfpp = interp1(control_feedback(1,i), control_feedback(2:end,i)', 'pchip', 'pp');

    t = linspace(0,max(control_feedback(1,i)),100);
    control_feedback = ppval(cfpp, t)';
    hold on;
    plot(t, control_feedback(1,:), 'r');
    plot(t, control_feedback(2,:), 'g');
    plot(t, control_feedback(3,:), 'b');    
    legend('u1', 'u2', 'u3');
end
