function [bv1, bv2] = find_new_basis(v)
v1 = v;
v2 = [1;0;0];
v3 = [0;1;0];
v4 = [0;0;1];

u1 = v1;
u2 = v2 - proj(u1, v2);
u3 = v3 - proj(u1, v3) - proj(u2, v3);
u4 = v4 - proj(u1, v4) - proj(u2, v4) - proj(u3, v4);

u1 = normlize(u1);
u2 = normlize(u2);
u3 = normlize(u3);
u4 = normlize(u4);

if rank([u1, u2, u3]) == 3
    B = [u1, u2, u3];
elseif rank([u1, u2, u4]) == 3
    B = [u1, u2, u4];        
else
    B = [u1, u3, u4];
end

bv1 = B(:,2);
bv2 = B(:,3);
end

function rv = proj(u,v)
if dot(u,u) ~= 0
    rv = (dot(v,u)/dot(u,u)*u);
else
    rv = [0;0;0];
end
end

function rv = normlize(v)
if (dot(v,v)) ~= 0
    rv = v / norm(v);
else
    rv = v;
end
end