function [C, Ceq] = nonlincon(x)
global radiuses number_of_points type

X = reshape(x, 3, number_of_points)';

C = [];
Ceq = [];

for i = 1:number_of_points
    C = [C; norm(X(i,:)) - radiuses(i)];
    Ceq = [Ceq; 0];
end

global point_list original_pp

points = point_list + X;
pp = interp1((0:(number_of_points-1))/(number_of_points-1), points, type, 'pp');

if pp.order ~= 4
    return
end

for i = 1:(number_of_points-1)
    tc = 0;
    index = 3*(i-1)+1;
    v = original_pp.coefs(index:(index+2),3);
    v = v/norm(v);

    % An affine tranformation to the origin
    a = pp.coefs(index:(index+2), 1);
	b = pp.coefs(index:(index+2), 2);
	c = pp.coefs(index:(index+2), 3);	
    d = pp.coefs(index:(index+2), 4);
    d(:) = 0;

    cf6 = ((a(2) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(2)) ^ 2 + (a(1) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(1)) ^ 2 + (a(3) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(3)) ^ 2) ;
    cf5 = (2 * (b(3) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(3)) * (a(3) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(3)) + 2 * (b(2) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(2)) * (a(2) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(2)) + 2 * (b(1) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(1)) * (a(1) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(1)));
    cf4 = (2 * (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(3) + c(3)) * (a(3) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(3)) + (b(3) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(3)) ^ 2 + 2 * (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(1) + c(1)) * (a(1) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(1)) + (b(1) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(1)) ^ 2 + 2 * (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(2) + c(2)) * (a(2) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(2)) + (b(2) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(2)) ^ 2);
    cf3 = (2 * (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(3) + d(3)) * (a(3) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(3)) + 2 * (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(3) + c(3)) * (b(3) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(3)) + 2 * (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(2) + d(2)) * (a(2) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(2)) + 2 * (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(2) + c(2)) * (b(2) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(2)) + 2 * (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(1) + d(1)) * (a(1) - (a(1) * v(1) + a(2) * v(2) + a(3) * v(3)) * v(1)) + 2 * (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(1) + c(1)) * (b(1) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(1)));
    cf2 = (2 * (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(2) + d(2)) * (b(2) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(2)) + (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(2) + c(2)) ^ 2 + 2 * (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(3) + d(3)) * (b(3) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(3)) + (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(3) + c(3)) ^ 2 + 2 * (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(1) + d(1)) * (b(1) - (b(1) * v(1) + b(2) * v(2) + b(3) * v(3)) * v(1)) + (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(1) + c(1)) ^ 2);
    cf1 = (2 * (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(3) + d(3)) * (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(3) + c(3)) + 2 * (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(2) + d(2)) * (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(2) + c(2)) + 2 * (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(1) + d(1)) * (-(c(1) * v(1) + c(2) * v(2) + c(3) * v(3)) * v(1) + c(1)));
    cf0 = (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(1) + d(1)) ^ 2 + (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(3) + d(3)) ^ 2 + (-(v(1) * d(1) + v(2) * d(2) + v(3) * d(3)) * v(2) + d(2)) ^ 2;
    df5 = 6*cf6;
    df4 = 5*cf5;
    df3 = 4*cf4;
    df2 = 3*cf3;
    df1 = 2*cf2;
    df0 = 1*cf1;    
    
    rts = roots([df5 df4 df3 df2 df1 df0]);
    
	for j=1:length(rts)
		if isreal(rts(j)) && rts(j) > 0 && rts(j) < 1/(number_of_points-1)      
            tcc = sqrt(abs(polyval([cf6 cf5 cf4 cf3 cf2 cf1 cf0], rts(j))));
			if tcc > tc
				tc = tcc;
			end
		end
    end
	
    C = [C; tc-radiuses(i)];
    Ceq = [Ceq; 0];
end

end