function objVal = objectivefunction(x, ssgrid)

taumax = [500;400;100];
% Lower and upper bounds for the torques.
torquelb = -taumax*0.8;
torqueub = taumax*0.8;

% The weighting.
gamma1 = 0;
gamma2 = 0;

% Set to 1 to allow Coulomb friction in the dynamic model.
coulomb = 0;


if nargin == 2
    sgrid = ssgrid;
else
    sgrid = 200;
end

global deltaPositions number_of_points

deltaPositions = reshape(x,3,number_of_points)';

% Fetch all path-dependent quantities.
[s, sm, ds, q, qp, qpp, Mv, Cv, gv] = dynpathparams(@invdyn, @pathfunction, sgrid, coulomb);
[a, b, c, d, tau, diagnostics] = timeoptpathconstrsed(s, sm, ds, q, qp, qpp, Mv, Cv, gv, torquelb, torqueub, gamma1(1), gamma2(1), 'sedumi');

% Obtain the time vector.
t = cumsum(2*ds./(sqrt(b(2:end))+sqrt(b(1:end-1))));
objVal = max(t);

end