function [M,C,g] = invdyn(q,qdot,coulomb)

%M = zeros(6,6,size(q,2));
%C = zeros(6,6,size(q,2));
%g = zeros(6,size(q,2));

fprintf('Generating dynamic model matrices...\n');
for k = 1:size(q,2)
	q1 = q(1,k);
	q2 = q(2,k);
    q3 = q(3,k);
    qs = [q1 q2 q3];

	qdot1 = qdot(1,k);
	qdot2 = qdot(2,k);
    qdot3 = qdot(3,k);
	dqs = [qdot1 qdot2 qdot3];

	M(:,:,k) = mass(qs);
	C(:,:,k) = pseudocoriolis(qs,dqs);
    g(:,k) = pseudogravity(qs,dqs);

end
fprintf('Done generating dynamic model matrices...\n');

