function [q, qp, qpp] = varyingpath(s)

global f1m df1m ddf1m f2m df2m ddf2m

q(:,1)   = pi/2*s;
qp(:,1)  = pi/2*ones(length(s),1);
qpp(:,1) = zeros(length(s), 1);

[pp1, dpp1, ddpp1] = mos(-pi/4, 0, f1m, df1m, ddf1m, pi/4, 0);

q(:,2)   = ppval(pp1, s);
qp(:,2)  = ppval(dpp1, s);
qpp(:,2) = ppval(ddpp1, s);

[pp2, dpp2, ddpp2] = mos(0, 0, f2m, df2m, ddf2m, 10/180*pi, 0);

q(:,3)   = ppval(pp2, s);
qp(:,3)  = ppval(dpp2, s);
qpp(:,3) = ppval(ddpp2, s);

q   = q';
qp  = qp';
qpp = qpp';