#ifndef __CONTROLS_H__
#define __CONTROLS_H__

#include <QtGui>
#include <vector>

#include <MSL/vector.h>


#include "camera.h"

class Controls : public QGroupBox
{
 Q_OBJECT
 private:
  vector<QDoubleSpinBox*> sliders;
  QFormLayout *layout;
  Camera *camera;
 public:
  QSpinBox *xposSpinBox;
  QSpinBox *yposSpinBox;
  QSpinBox *zposSpinBox;
  QScrollBar *rotScrollBar;
  Controls(Camera *camera, QWidget *parent = 0);
  void addLink(double lowerState, double upperState);
  MSLVector getState();
  void setState(MSLVector);
 public slots:
  void updateState();
  void updateCamera();
  void printConfigurationClicked();
 signals:
  void stateChanged();
  void cameraChanged();
  void printConfiguration();
};

#endif
