/**
 * Program used to convert from the RAW file format exported by Blender to the raw file format used by the Motion Strategy Library.
 */
#include <iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <stdio.h>
#include <vector>
#include <string.h>

using namespace std;



void add(vector<double> verts, ofstream & fout)
{
  // Triangles in - triangles out
  if (verts.size() == 9) {
    fout << "(" << verts[0] 
	 << ","<<verts[1]
	 <<","<<verts[2]
	 <<") ("<<verts[3]
	 <<","<<verts[4]
	 <<","<<verts[5]
	 <<") ("<<verts[6]
	 <<","<<verts[7]
	 <<","<<verts[8]
	 <<")"<<endl;
  }
  // Quadrangles in - triangles out
  else if (verts.size() == 12) {
    fout << "(" << verts[0] 
	 << ","<<verts[1]
	 <<","<<verts[2]
	 <<") ("<<verts[3]
	 <<","<<verts[4]
	 <<","<<verts[5]
	 <<") ("<<verts[6]
	 <<","<<verts[7]
	 <<","<<verts[8]
	 <<")"<<endl;
    fout << "(" << verts[0] 
	 << ","<<verts[1]
	 <<","<<verts[2]
	 <<") ("<<verts[6]
	 <<","<<verts[7]
	 <<","<<verts[8]
	 <<") ("<<verts[9]
	 <<","<<verts[10]
	 <<","<<verts[11]
	 <<")"<<endl;
  }
}

int main(int argc, char *argv[]) {
  if (argc <= 2) {
    cout << "Need two arguments" << endl;
  }  

  char buffer[100];
  ifstream fin(argv[1]);
  ofstream fout(argv[2]);

  string line;
  double d;
  while(getline(fin, line)) {
    vector<double> row;
    stringstream ss(line);

    while(ss >> d) {
      row.push_back(d);
    }

    add(row, fout);
  }
  
  fin.close();
  fout.close();
  return 0;
}
