#include <GL/gl.h>
#include "environment.h"

Environment::Environment(string path) : Link(path)
{
  BMPLoad("data/textures/wood2.bmp", bmp);
  glEnable(GL_TEXTURE_2D);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexImage2D(GL_TEXTURE_2D,0,3,bmp.width,bmp.height,0,GL_RGB,GL_UNSIGNED_BYTE,bmp.bytes);
  glDisable(GL_TEXTURE_2D);
}


void Environment::draw()
{
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glTranslatef(pos[0], pos[1], pos[2]);

  glRotatef(rot[2]*180.0/PI, 0.0, 0.0, 1.0);
  glRotatef(rot[1]*180.0/PI, 0.0, 1.0, 0.0);
  glRotatef(rot[0]*180.0/PI, 1.0, 0.0, 0.0);

  //  glColor3f(color[0], color[1], color[2]);
  glColor3f(1.0, 1.0, 1.0);
  glEnable(GL_TEXTURE_2D);
  glBegin(GL_TRIANGLES);
  for (unsigned int i=0;i<polygons.size(); i++) {
    glNormal3f(polygons[i].nx,   polygons[i].ny,   polygons[i].nz);
    glTexCoord2d(0, 1); glVertex3f(polygons[i].pt1x, polygons[i].pt1y, polygons[i].pt1z);
    glNormal3f(polygons[i].nx,   polygons[i].ny,   polygons[i].nz);
    glTexCoord2d(1,1);glVertex3f(polygons[i].pt2x, polygons[i].pt2y, polygons[i].pt2z);
    glNormal3f(polygons[i].nx,   polygons[i].ny,   polygons[i].nz);
    glTexCoord2d(1,0);glVertex3f(polygons[i].pt3x, polygons[i].pt3y, polygons[i].pt3z);
  }
  glEnd();
    glDisable(GL_TEXTURE_2D);
  glPopMatrix();

}

