#include <GL/gl.h>
#include "frame.h"

Frame::Frame()
{
  pos[0] = 0;
  pos[1] = 0;
  pos[2] = 0;

  rot[0] = 0;
  rot[1] = 0;
  rot[2] = 0;
}

void Frame::setTransform(float posx, float posy, float posz, float rotx, float roty, float rotz)
{
  pos[0] = posx;
  pos[1] = posy;
  pos[2] = posz;
  rot[0] = rotx;
  rot[1] = roty;
  rot[2] = rotz;
}

void Frame::drawCoordinateSystem()
{
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glTranslatef(pos[0], pos[1], pos[2]);

  glRotatef(rot[2]*180.0/PI, 0.0, 0.0, 1.0);
  glRotatef(rot[1]*180.0/PI, 0.0, 1.0, 0.0);
  glRotatef(rot[0]*180.0/PI, 1.0, 0.0, 0.0);

  glLineWidth(2);
  glBegin(GL_LINES);
  glColor3f(1.0, 0.0, 0.0);
  glVertex3f(0.0, 0.0, 0.0);
  glVertex3f(200.0, 0.0, 0.0);
  glColor3f(0.0, 1.0, 0.0);
  glVertex3f(0.0, 0.0, 0.0);
  glVertex3f(0.0, 200.0, 0.0);
  glColor3f(0.0, 0.0, 1.0);
  glVertex3f(0.0, 0.0, 0.0);
  glVertex3f(0.0, 0.0, 200.0);
  glEnd();
  glPopMatrix();
}
