#include "geomirb.h"


GeomIRB::GeomIRB(string path = ""):GeomPQP3DRigidMulti(path) {
}

GeomIRB_DistanceResult GeomIRB::DistanceCompute(const MSLVector &q) {
  int i,j;
  list<MSLVector>::iterator v;
  
  GeomIRB_DistanceResult dist;

  PQP_DistanceResult dres;  
  SetTransformation(q);

  // Check for collisions with obstacles
  for (i = 0; i < NumBodies; i++) {    
    PQP_Distance(&dres,RR[i],TR[i],&Ro[i],RO,TO,&Ob,0.0,0.0);    
    if (dres.Distance() < dist.distance[i])
      dist.distance[i] = dres.Distance();
  }
  
  // Check for pairwise collisions
  forall(v,CollisionPairs) {
    i = (int) v->operator[](0); 
    j = (int) v->operator[](1);
    PQP_Distance(&dres,RR[i],TR[i],&Ro[i],RR[j],TR[j],&Ro[j],0.0,0.0);    
    if (dres.Distance() < dist.distance[i])
      dist.distance[i] = dres.Distance();
  }

  return dist;
  
}
