#ifndef __GLWIDGET_H__
#define __GLWIDGET_H__

#include <QtGui>
#include <QGLWidget>

#include <vector>

#include "link.h"
#include "camera.h"
#include "extra/bmpwriter.h"

using namespace std;

#ifndef PI
#define PI 3.14157f
#endif

class GLWidget : public QGLWidget 
{
 Q_OBJECT
 private:
  float pos[3];
  float rot[3];
  vector<Link*> links;
  Camera cam;
  int lastX, lastY;
  int width, height;
 public:
  GLWidget(QWidget *parent = 0);
  void addLink(Link* link);
  Camera* getCamera() { return &cam; }
 protected:
  void initializeGL();
  void resizeGL(int w, int h);
  void paintGL();
  void drawCoordinateSystem();
  void setTransform(float posx, float posy, float posz, float rotx, float roty, float rotz);
  void useTransform();
  void mousePressEvent(QMouseEvent *e);
  void mouseMoveEvent(QMouseEvent *e);
  void keyReleaseEvent(QKeyEvent *e);
  void wheelEvent(QWheelEvent *e);
 public slots:
  void refresh();
  void update();
 signals:
  void mustUpdate();
};

#endif
