#ifndef __IRBRENDERER_H__
#define __IRBRENDERER_H__

#include <vector>
#include <string>
#include <QtGui>
#include <MSL/vector.h>

#include "modelirb.h"
#include "modelirbtwins.h"
#include "frame.h"
#include "link.h"

using namespace std;

class IRBRenderer : public QObject
{
  Q_OBJECT
 private:
  string path;
  ModelIRB *model;
  vector <Link*> graphicalLinks;
  vector <Link*> collisionLinks;
  vector <Frame*> frames;  
 public:
  IRBRenderer(string path, ModelIRB *model);
  QWidget *getControlWidget(unsigned int index);
  string getName(unsigned int index);
  void renderGraphicalModels();
  void renderCollisionModels();
  void renderCoordinateSystems();
  void renderLineModel();
  void stateToConfiguration(MSLVector state);
  unsigned int numLinks();
 public slots:
  void refresh();
 signals:
  void update();
};

#endif
