#ifndef __LINK_H__
#define __LINK_H__

#include <iostream>
#include <vector>
#include <string>

#include "frame.h"
#include "triangle.h"

using namespace std;

class Link : public Frame 
{
 protected:
  string filename;
  float color[3];
  vector<Triangle> polygons;
 public:
  Link(string filename);  
  void setColor(float r, float g, float b) {color[0] = r; color[1] = g; color[2] = b;}
  void draw();
  void drawCoordinateSystem();
  void translate(float x, float y, float z);
  void rotate(double psi, double theta, double phi);
  void scale(double x, double y, double z);
  void switchDirection();
  void save();
};

#endif
