#include <math.h>
#include <cstdlib>
#include <string>
#include <MSL/vector.h>

#include <QApplication>

#include "window.h"
#include "glwidget.h"
#include "pathoptimization.h"


int main(int argc, char *argv[]) {
  QApplication app(argc, argv);

  Window window;
  window.show();  
  
  string path = "data/irb";
  ModelIRBSingle* model = new ModelIRBSingle(path);

  window.setModel(model, path);

  PathOptimization* objective = window.getObjective();
  objective->setRobot(model);

  Environment* environment = new Environment(path+string("/Obst"));
  window.setEnvironment(environment);

  return app.exec();

  return 0;
}
