#ifndef __MODELIRBSINGLE_H__
#define __MODELIRBSINGLE_H__

#include "modelirb.h"

class ModelIRBSingle : public ModelIRB
{
 private:
  MSLVector DH;
  vector<int> StateIndices;
  vector<MSLVector> CornerRobot0;
  vector<MSLVector> CornerRobot1;
  vector<MSLVector> CornerRobot2;
  vector<MSLVector> CornerRobot3;
  vector<MSLVector> CornerRobot4;
  vector<MSLVector> CornerRobot5;
 public:
  ModelIRBSingle(string path);
  MSLVector StateToConfiguration(const MSLVector &x);
  float MaximumRobotDisplacement(const MSLVector &qDelta);
  bool angle(const MSLVector &q);
  bool Satisfied(const MSLVector &x);
  void LoadCornerPoints();
  void LoadCornerPointsFromFile(string filename, vector<MSLVector> &corners);
  void AddCornerPoint(MSLVector point, vector<MSLVector> & corners);
  void LipschitzConstants(const MSLVector &x, float c[36]);
  double PointToLineDistance(const MSLVector &point, 
			     const MSLVector &pointOnLine,
			     const MSLVector &lineVector);
  void test();
};

#endif
