#ifndef __MODELIRBTWINS_H__
#define __MODELIRBTWINS_H__

#include <MSL/model3d.h>
#include "modelirb.h"

class ModelIRBTwins : public ModelIRB
{
 private:
  float tolerance;
  MSLVector DH1; // Robot 1
  MSLVector DH2; // Robot 2
  MSLVector trans; // transformation from base of DH chain 1 to DH chain 2
  int StateDim1;
  int StateDim2;
  vector<int> StateIndices1;
  vector<int> StateIndices2;
  float gamma;
 public:
  float distance;
  //  int NumBodies;
  ModelIRBTwins(string path);
  MSLVector StateToConfiguration(const MSLVector &x);
  void setDistance(float distance);
  void setTolerance(float tolerance);
  void setGamma(float gamma);
  bool Satisfied(const MSLVector &x);
  double dist(const MSLVector &x);
  bool angle(const MSLVector &x);
};

#endif
