#ifndef __PATHOPTIMIZATION_H__
#define __PATHOPTIMIZATION_H__

#include <MSL/geomPQP.h>
#include <MSL/problem.h>
#include "vector.h"
#include "modelirb.h"
#include "modelirbsingle.h"
#include "spline.h"
#include "geomirb.h"

class PathOptimization
{
 private:
  Spline *spline;
  Problem *problem;
  ModelIRBSingle *irb;
  GeomIRB *geom;
  //  float *c;
 public:
  PathOptimization();
  void setSpline(Spline *spline);
  void setProblem(Problem *problem);
  void setGeom(GeomIRB *geom);
  void setRobot(ModelIRBSingle *irb);
  void straighten();
  void shortcut();
  void straighten2();
  void divide();
  bool lineCheck(Vector &q1, Vector &q2, unsigned int depth);
};

#endif
