#include "settings.h"

Settings::Settings(QWidget *parent) : QGroupBox(parent)
{
  drawGraphicalModel = true;
  drawCollisionModel = true;
  drawCoordinateSystems = true;
  drawEnvironment = true;

  QFormLayout *layout = new QFormLayout;
  setLayout(layout);

  QPushButton *button = new QPushButton("Draw coordinate systems");
  layout->setWidget(0, QFormLayout::SpanningRole, button);
  connect(button, SIGNAL(clicked()),
	  this, SLOT(toggleDrawCoordinateSystems()));
  button = new QPushButton("Draw graphical model");
  layout->setWidget(1, QFormLayout::SpanningRole, button);
  connect(button, SIGNAL(clicked()),
	  this, SLOT(toggleDrawGraphicalModel()));
  button = new QPushButton("Draw collision model");
  layout->setWidget(2, QFormLayout::SpanningRole, button);
  connect(button, SIGNAL(clicked()),
	  this, SLOT(toggleDrawCollisionModel()));
  button = new QPushButton("Draw line model");
  layout->setWidget(3, QFormLayout::SpanningRole, button);
  connect(button, SIGNAL(clicked()),
	  this, SLOT(toggleDrawLineModel()));
  button = new QPushButton("Draw environment");
  layout->setWidget(4, QFormLayout::SpanningRole, button);
  connect(button, SIGNAL(clicked()),
	  this, SLOT(toggleEnvironment()));
}

void Settings::toggleDrawCoordinateSystems()
{
  drawCoordinateSystems = !drawCoordinateSystems;
  emit update();
}

void Settings::toggleDrawGraphicalModel()
{
  drawGraphicalModel = !drawGraphicalModel;

  emit update();
}

void Settings::toggleDrawCollisionModel()
{
  drawCollisionModel = !drawCollisionModel;
  emit update();
}

void Settings::toggleDrawLineModel()
{
  drawLineModel = !drawLineModel;
  emit update();
}

void Settings::toggleEnvironment()
{
  drawEnvironment = !drawEnvironment;
  emit update();
}


#include "moc_settings.cpp"
