#ifndef __DISPLAY_H__
#define __DISPLAY_H__

#include <QtGui>

class Settings : public QGroupBox {
  Q_OBJECT
  private:
  bool drawCoordinateSystems;
  bool drawGraphicalModel;
  bool drawCollisionModel;
  bool drawLineModel;
  bool drawEnvironment;
  public:
  Settings(QWidget *parent = 0);
  bool showCoordinateSystems() {return drawCoordinateSystems;}
  bool showGraphicalModel() {return drawGraphicalModel;}
  bool showCollisionModel() {return drawCollisionModel;}
  bool showLineModel() {return drawLineModel;}
  bool showEnvironment() {return drawEnvironment;}
 public slots:
  void toggleDrawCoordinateSystems();
  void toggleDrawGraphicalModel();
  void toggleDrawCollisionModel();
  void toggleDrawLineModel();
  void toggleEnvironment();
 signals:
  void update();
};

#endif
