#ifndef __SPLINE_H__
#define __SPLINE_H__

#include <math.h>

#include <MSL/vector.h>
#include <vector>
#include "vector.h"

/*
class Patch
{
 public:
  unsigned int dimensions;
  Vector &p0, &p1, m0, m1;
  Patch(unsigned int dimensions);
  Vector evaluate(double t);
  };*/

class Spline
{
 private:
  //  std::vector<Patch> patches;
  std::vector<Vector> points;
  std::vector<Vector> storedPoints;
  std::vector<double> radius;
 public:
  unsigned int dimensions;
  Spline(unsigned int dimensions);
  //  void add(MSLVector p0, MSLVector p1);
  void add(MSLVector p);
  void shortcut(double t1, double t2);
  Vector evaluate(double t);
  void clear();
  void remove(unsigned int position);
  unsigned int numPoints();
  Vector getPoint(unsigned int);
  void setPoint(unsigned int, Vector);
  Vector operator[](int) const;
  Vector& operator[](int);
  void divide();
  void store();
  void restore();
  double length();
};

#endif
