#include <GL/gl.h>
#include "splinerenderer.h"

void SplineRenderer::render()
{
  MSLVector a, b;
  glBegin(GL_LINES);
  MSLVector t1, t2;
  unsigned int numDivisions = 1000;
  for (unsigned int i=0; i<numDivisions-1; i++) {
    t1 = spline->evaluate(i/(float)numDivisions);
    t2 = spline->evaluate((i+1)/(float)numDivisions);
    if (t1.dim() > 0) {
      a = problem->StateToConfiguration(t1);
      glVertex3f(a[a.dim()-6], a[a.dim()-5], a[a.dim()-4]);
      b = problem->StateToConfiguration(t2);
      glVertex3f(b[b.dim()-6], b[b.dim()-5], b[b.dim()-4]);
    }
  }
  glEnd();


  glPointSize(10.0);
  glBegin(GL_POINTS);
  glColor3f(1.0, 0.0, 0.0);
  for (unsigned int i=0; i<spline->numPoints(); i++) {
    a = problem->StateToConfiguration(spline->getPoint(i));
    glVertex3f(a[a.dim()-6], a[a.dim()-5], a[a.dim()-4]);
  }
  glEnd();

  /*  glPointSize(10.0);
  glBegin(GL_POINTS);
  glColor3f(1.0, 0.0, 1.0);
  MSLVector midPoint;
  unsigned int numPoints = spline->numPoints();
  for (unsigned int i=2; i<spline->numPoints(); i++) {
    midPoint = (spline->getPoint(i-2) + spline->getPoint(i))*0.5;
    glColor3f(1.0, 0.0, 1.0);
    a = problem->StateToConfiguration(midPoint);
    glVertex3f(a[a.dim()-6], a[a.dim()-5], a[a.dim()-4]);
  }
  glEnd();

  glBegin(GL_POINTS);
  glColor3f(0.0, 1.0, 0.0);
  MSLVector dustePoint;
  for (unsigned int i=2; i<spline->numPoints(); i++) {
    dustePoint = (spline->getPoint(i-2)+spline->getPoint(i) - spline->getPoint(i-1)*2)*0.2;

    a = problem->StateToConfiguration(dustePoint);
    glVertex3f(a[a.dim()-6], a[a.dim()-5], a[a.dim()-4]);
  }
  glEnd();
*/
}
