#ifndef __TRANSFORM_H__
#define __TRANSFORM_H__

#include <QtGui>

#include "link.h"

class Transform : public QGroupBox {
  Q_OBJECT
 private:
  QDoubleSpinBox *transX;
  QDoubleSpinBox *transY;
  QDoubleSpinBox *transZ;
  QDoubleSpinBox *rotX;
  QDoubleSpinBox *rotY;
  QDoubleSpinBox *rotZ;
  QDoubleSpinBox *scaleX;
  QDoubleSpinBox *scaleY;
  QDoubleSpinBox *scaleZ;
  QFormLayout *layout;
  Link *link;
 public:
  Transform(string str, Link *link, QWidget *parent = 0);
 public slots:
  void applyTransformation();
  void applyRotation();
  void applyScaling();
  void save();
  void switchDirection();
 signals:
  void update();
};

#endif
