#include <GL/gl.h>
#include "treerenderer.h"

void TreeRenderer::renderBranch(MSLNode *parent)
{
  //  cout << "renderBranch" << endl;
  MSLVector a, b;
  a = problem->StateToConfiguration(parent->State());
  
  list<MSLNode*> children = parent->Children();
  list<MSLNode*>::iterator it = children.begin();
  for (; it != children.end(); it++) {
    b = problem->StateToConfiguration((*it)->State());
    glVertex3f(a[a.dim()-6], a[a.dim()-5], a[a.dim()-4]);
    //    cout << a[a.dim()-6] << "," << a[a.dim()-5] << "," << a[a.dim()-4] << endl;
    glVertex3f(b[b.dim()-6], b[b.dim()-5], b[b.dim()-4]);
    //    cout << b[b.dim()-6] << "," << b[b.dim()-5] << "," << b[b.dim()-4] << endl;
    renderBranch(*it);
  }

}

void TreeRenderer::render()
{
  glBegin(GL_LINES);
  if (planner->T != NULL) {
    //    cout << "planner->T->Size() : " << planner->T->Size() << endl;
    renderBranch(planner->T->Root());
    //    cout << "planner->T2->Size() : " << planner->T2->Size() << endl;
    renderBranch(planner->T2->Root());
  }
  glEnd();
}


