#include <math.h>
#include <cstdio>

#include "triangle.h"

Triangle::Triangle(float pt1x, float pt1y, float pt1z,
		   float pt2x, float pt2y, float pt2z,
		   float pt3x, float pt3y, float pt3z)
{
  this->init(pt1x, pt1y, pt1x,
	     pt2x, pt2y, pt2z,
	     pt3x, pt3y, pt3z);
}

Triangle::Triangle(string str)
{
  float pts[9];
  sscanf(str.c_str(), "(%f,%f,%f) (%f,%f,%f) (%f,%f,%f)", 
	 &pts[0], &pts[1], &pts[2], 
	 &pts[3], &pts[4], &pts[5],
	 &pts[6], &pts[7], &pts[8]);
  this->init(pts[0], pts[1], pts[2],
	     pts[3], pts[4], pts[5],
	     pts[6], pts[7], pts[8]);
}

void Triangle::init(float pt1x, float pt1y, float pt1z,
		    float pt2x, float pt2y, float pt2z,
		    float pt3x, float pt3y, float pt3z)
{
  this->pt1x = pt1x;
  this->pt1y = pt1y;
  this->pt1z = pt1z;
  this->pt2x = pt2x;
  this->pt2y = pt2y;
  this->pt2z = pt2z;
  this->pt3x = pt3x;
  this->pt3y = pt3y;
  this->pt3z = pt3z;

  calcNormal();
}

void Triangle::calcNormal()
{
  nx = (this->pt2y-this->pt1y)*(this->pt2z-this->pt3z) - (this->pt2z-this->pt1z)*(this->pt2y-this->pt3y);
  ny = (this->pt2z-this->pt1z)*(this->pt2x-this->pt3x) - (this->pt2x-this->pt1x)*(this->pt2z-this->pt3z);
  nz = (this->pt2x-this->pt1x)*(this->pt2y-this->pt3y) - (this->pt2y-this->pt1y)*(this->pt2x-this->pt3x);

  double l = sqrt(nx*nx + ny*ny + nz*nz);
  nx = nx/l;
  ny = ny/l;
  nz = nz/l;
}
