#include "vector.h"

Vector::Vector(int dimension) : dimension(dimension)
{
  d = new double[dimension];
  for (int i=0; i<dimension; i++) {
    d[i] = 0.0f;
  }
}

Vector::Vector(MSLVector v) : dimension(v.dim())
{
  d = new double[dimension];
  for (int i=0; i<dimension; i++) {
    d[i] = v[i];
  }
}

double Vector::operator[](int i) const
{
  return d[i];
}

double& Vector::operator[](int i)
{
  return d[i];
}

Vector Vector::operator+(Vector v)
{
  Vector r(dimension);
  for (int i=0; i<dimension; i++) {
    r[i] = d[i] + v[i];
  }
  return r;
}

Vector Vector::operator-(Vector v)
{
  Vector r(dimension);
  for (int i=0; i<dimension; i++) {
    r[i] = d[i] - v[i];
  }
  return r;
}

Vector Vector::operator*(double f)
{
  Vector r(dimension);
  for (int i=0; i<dimension; i++) {
    r[i] = f * d[i];
  }
  return r;
}

Vector::operator MSLVector()
{
  MSLVector r(dimension);

  for (int i=0; i<dimension; i++) {
    r[i] = d[i];
  }

  return r;
}

MSLVector convert2MSL(Vector v)
{
  MSLVector mv(v.dimension);
  for (int i=0; i<v.dimension; i++) {
    mv[i] = v[i];
  }
  return mv;
}
