#ifndef __VECTOR_H__
#define __VECTOR_H__

#include <iostream>
#include <MSL/vector.h>

class Vector
{
 public:
  double *d;
  int dimension;
  Vector(int dimension);
  Vector(MSLVector);
  double operator[](int) const;
  double& operator[](int);
  Vector operator+(Vector);
  Vector operator-(Vector);
  Vector operator*(double f);
  operator MSLVector();
  friend std::ostream& operator << (std::ostream& strm, const Vector& vec) {
    for (int i =0; i< vec.dimension; i++) {
      strm << vec.d[i] << " ";
    }
    return strm;
  }
};

MSLVector convert2MSL(Vector v);



#endif
