#ifndef __window_h__
#define __window_h__

#include <QtGui>
#include <QWidget>
#include <vector>

#include <MSL/vector.h>
#include <MSL/geom.h>
#include <MSL/geomPQP.h>
#include <MSL/problem.h>
#include <MSL/rrt.h>

#include "modelirb.h"
#include "modelirbtwins.h"
#include "modelirbsingle.h"
#include "glwidget.h"
#include "camera.h"
#include "path.h"
#include "controls.h"
#include "settings.h"
#include "environment.h"
#include "pathoptimization.h"
#include "irbrenderer.h"
#include "geomirb.h"

class Window : public QWidget {
  Q_OBJECT
 private:
  MSLVector configuration;
  ModelIRB *model;
  GeomIRB *geom;
  Problem *prob;
  Path *path;
  Settings *settings;
  QTabWidget *tabs;
  IRBRenderer *irbrenderer;
  Environment *environment;
  GLWidget *glWidget;  
  Controls *controls;
 public:
  Window(QWidget *parent = 0);
  void update();
  void setEnvironment(Environment *environment);
  void setModel(ModelIRB *_model, string path);
  PathOptimization* getObjective();
  //  void setRobot(
 public slots:
  void updateConfiguration();
  void updateCamera();
  void stateToConfiguration();
  void refresh();
  void printConfiguration();
};
#endif
