addpath(strcat(fileparts(pwd), '\rrt'))

rrt = rrt_init([0.1627,0.5695], [0.95, 0.55]);
%rrt = rrt_init([0.4, 0.55], [0.1627,0.5695]);
geometry = generate_problem();

%cCheck = @(pointA, pointB)(collision_check(pointA, pointB, geometry));

for i=1:1500
    if strcmp(rrt.status, 'solved')
        break;
    end
    new_point = rand(1,2);
    rrt = rrt_extend(rrt, new_point, 0.05, @collision_check, geometry);
end
H = figure(1);
set(H, 'name', 'Path found by RRT');
rrt_plot(rrt);
draw_geometry(geometry);
title(sprintf('Number of nodes: %i', size(rrt.vertices,1)));

%disp('Press a key to remove redundant nodes')
%pause
path = rrt_get_solution(rrt);
rrpath = remove_redundants(path, @collision_check, geometry);
H = figure(2);
set(H, 'name', 'Removed redundant nodes');
rrt_plot(rrt);
draw_geometry(geometry);
rrt_plot_path(rrpath, 'm');

%disp('Press a key to make shortcuts')
%pause
scpath = shortcut(path, @collision_check, geometry);
H = figure(3);
set(H, 'name', 'Result after making Shortcuts');
rrt_plot(rrt);
draw_geometry(geometry);
rrt_plot_path(scpath, 'm');