function rrt_plot(rrt)
    axis([0 1 0 1]);
    hold on    

    plot(rrt.initial_point(1), rrt.initial_point(2), 'rO');
    if ~strcmp(rrt.status, 'not_a_problem')
        plot(rrt.goal_point(1), rrt.goal_point(2), 'mO');    
    end
    
% Plot Voronoi regions
%     if (size(rrt.vertices,1)) > 2
%         [vx,vy] = voronoi(rrt.vertices(:,1), rrt.vertices(:,2), 'b');
%         plot(vx,vy, 'b');
%     end    


% Mark individual vertices
%     for i=1:length(rrt.vertices)
%         p = rrt.vertices(i,:);
%         plot(p(1), p(2), 'r*');
%     end

    % Plot tree edges
    for i=1:length(rrt.edges)
        edge = rrt.edges{i};
        p1 = rrt.vertices(edge(1),:);
        p2 = rrt.vertices(edge(2),:);
        points = [p1;p2];
        plot(points(:,1), points(:,2), 'g');
    end

    % Plot solution
    if strcmp(rrt.status, 'solved')
        path = rrt_get_solution(rrt);
        rrt_plot_path(path, 'b');
    end
    
%     if strcmp(rrt.status, 'solved')
%        %curIndex = rrt.parent_of_vertex(length(rrt.parent_of_vertex));
%        curIndex = length(rrt.vertices);
%        while curIndex ~= 0
%         p1 = rrt.vertices(curIndex,:);
%         curIndex = rrt.parent_of_vertex(curIndex);        
%         if curIndex == 0
%             break;
%         end
%         p2 = rrt.vertices(curIndex,:);
%         points = [p1;p2];
%         plot(points(:,1), points(:,2), 'b', 'LineWidth', 2);        
%        end
%     end
    
end