function mat = Aaux_r1(th)

t = get_time(th);

theta = Theta(t);
Dtheta = DTheta(theta);
DDtheta = DDTheta(theta);
DDDtheta = DDDTheta(theta);

global a d g gravity m1 m2 m3 m load c1x c2x c2y c3z 
global l r1 r2 r3 h1 h2 h3 xx1 xx2 xx3 yy1 yy2 yy3 zz1 zz2 zz3
global Iota xxl yyl zzl x y z Kd1 Kd2 Kd3 Kp1 Kp2 Kp3

phd1 = phi1(theta);
phd2 = phi2(theta);
phd3 = phi3(theta);

dphd1 = dphi1(theta);
dphd2 = dphi2(theta);
dphd3 = dphi3(theta);

ddphd1 = ddphi1(theta);
ddphd2 = ddphi2(theta);
ddphd3 = ddphi3(theta);

dddphd1 = dddphi1(theta);
dddphd2 = dddphi2(theta);
dddphd3 = dddphi3(theta);

h_a = DDtheta;
dh_a = DDDtheta;

mat = [2 * Dtheta * DDtheta * dh_a / (2 * Dtheta ^ 2 + 2 * DDtheta ^ 2) 0 0.2e1 * Dtheta * (0.2e1 * a(2) ^ 2 * m(3) * dphd1 ^ 2 * (Dtheta ^ 2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos((2 * phd3 + 2 * phd2)) - a(2) * m(3) * l(c3z) * dphd1 ^ 2 * (Dtheta ^ 2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * sin((3 * phd3 + 2 * phd2)) + a(2) ^ 3 * m(3) * l(c3z) * dphd1 ^ 2 * (Dtheta ^ 2) * sin((-phd3 + 2 * phd2)) + a(2) * m(3) * l(c3z) * dphd1 ^ 2 * (Dtheta ^ 2) * (-0.2e1 * Iota(yy3) + Iota(xx3) - Iota(zz3) - l(c3z) ^ 2 + a(2) ^ 2) * sin((phd3 + 2 * phd2)) - a(2) * gravity * ((m(2) + m(3)) * a(2) - m(2) * l(c2x)) * l(c3z) * sin((phd2 - phd3)) + l(c3z) * a(2) * (a(2) * (Dtheta ^ 2) * dphd1 ^ 2 * a(1) * m(3) + gravity * l(c2y) * m(2)) * cos((phd2 - phd3)) - l(c3z) ^ 2 * a(2) * gravity * m(3) * cos((phd2 + 2 * phd3)) - a(2) * a(1) * m(3) * l(c3z) ^ 2 * dphd1 ^ 2 * (Dtheta ^ 2) * sin((phd2 + 2 * phd3)) + a(2) * gravity * ((m(2) - m(3)) * a(2) - m(2) * l(c2x)) * l(c3z) * sin((phd2 + phd3)) + l(c3z) * a(2) * (a(2) * (Dtheta ^ 2) * dphd1 ^ 2 * a(1) * m(3) - gravity * l(c2y) * m(2)) * cos((phd2 + phd3)) + 0.2e1 * a(2) ^ 2 * m(3) * dphd1 ^ 2 * (Dtheta ^ 2) * (Iota(yy3) + l(c3z) ^ 2) * cos((2 * phd2)) - 0.2e1 * gravity * (((m(3) / 0.2e1 + m(2)) * l(c3z) ^ 2 + Iota(yy3) * (m(2) + m(3))) * a(2) - m(2) * l(c2x) * (Iota(yy3) + l(c3z) ^ 2)) * cos(phd2) - (a(2) * (Dtheta ^ 2) * a(1) * m(3) * (l(c3z) ^ 2 + 0.2e1 * Iota(yy3)) * dphd1 ^ 2 + 0.2e1 * gravity * l(c2y) * m(2) * (Iota(yy3) + l(c3z) ^ 2)) * sin(phd2)) / dphd3 / (0.2e1 * Iota(yy3) + l(c3z) ^ 2 + l(c3z) ^ 2 * cos((2 * phd3))) / a(2) ^ 2 / m(3) 0.4e1 * (Dtheta ^ 2) * dphd1 * (l(c3z) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos((3 * phd3 + 2 * phd2)) / 0.2e1 + a(2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * sin((2 * phd3 + 2 * phd2)) - a(2) ^ 2 * l(c3z) * cos((-phd3 + 2 * phd2)) / 0.2e1 - l(c3z) * (-0.2e1 * Iota(yy3) + Iota(xx3) - Iota(zz3) - l(c3z) ^ 2 + a(2) ^ 2) * cos((phd3 + 2 * phd2)) / 0.2e1 + a(1) * l(c3z) ^ 2 * cos((phd2 + 2 * phd3)) + l(c3z) * a(2) * a(1) * sin((phd2 - phd3)) + l(c3z) * a(2) * a(1) * sin((phd2 + phd3)) + a(2) * (Iota(yy3) + l(c3z) ^ 2) * sin((2 * phd2)) - l(c3z) ^ 2 * a(2) * sin((2 * phd3)) + l(c3z) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2) * cos(phd3) + a(1) * cos(phd2) * (l(c3z) ^ 2 + 0.2e1 * Iota(yy3))) / a(2) / dphd3 / (0.2e1 * Iota(yy3) + l(c3z) ^ 2 + l(c3z) ^ 2 * cos((2 * phd3))) 0.8e1 * (Dtheta ^ 2) * (-(dphd3 / 0.4e1 + dphd2) * a(2) * l(c3z) * sin((2 * phd3)) + cos(phd3) * ((Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2) * dphd2 + dphd3 * (Iota(yy3) + l(c3z) ^ 2) / 0.2e1)) * l(c3z) / a(2) / dphd3 / (0.2e1 * Iota(yy3) + l(c3z) ^ 2 + l(c3z) ^ 2 * cos((2 * phd3))); 0 0 0 1 0; 0 0 0 0 1; 0.1e1 / (2 * Dtheta ^ 2 + 2 * DDtheta ^ 2) * (Dtheta * (-(2 * ddphd1 * Dtheta) - 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) / m(3) * (m(3) * (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd3 + dphd2) * sin(phd3) + l(c3z) * (dphd3 / 0.2e1 + dphd2) * a(2)) * cos(phd2) ^ 2 + ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd3 + dphd2) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 / 0.2e1 + dphd2) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 + dphd3 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd3 + dphd2) * sin(phd3) + dphd2 * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd3 + dphd2)) * dphd1 * Dtheta + m(3) * (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) * dphd1 + 0.2e1 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * m(3) * dphd2 * Dtheta - 0.2e1 * dphd1 * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd3 * Dtheta) - dphd1 / dphd3 * (-(2 * ddphd3 * Dtheta) - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-0.2e1 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * Dtheta * m(3) - 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * Dtheta * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd3 + dphd2) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3) - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * dphd1 ^ 2 * Dtheta * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * Dtheta)) + 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) / m(3) * (0.2e1 * m(3) * (-l(c3z) ^ 2 * cos(phd2) ^ 2 + Iota(xx3) + 0.2e1 * Iota(zz3) * cos(phd2) * cos(phd3) * sin(phd2) * sin(phd3) - 0.2e1 * Iota(xx3) * cos(phd2) * cos(phd3) * sin(phd2) * sin(phd3) + Iota(zz3) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * sin(phd2) * sin(phd3) * a(1) + 0.2e1 * l(c3z) * cos(phd2) * cos(phd3) * a(1) + 0.2e1 * Iota(xx3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 + a(1) ^ 2 + a(2) ^ 2 - 0.2e1 * l(c3z) ^ 2 * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) + 0.2e1 * l(c3z) ^ 2 * cos(phd2) ^ 2 * cos(phd3) ^ 2 + l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * cos(phd2) * sin(phd2) * cos(phd3) + 0.2e1 * a(2) * sin(phd2) * a(1) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + 0.2e1 * l(c3z) * a(2) * cos(phd2) ^ 2 * sin(phd3) + Iota(zz3) * cos(phd2) ^ 2 - Iota(xx3) * cos(phd3) ^ 2 - Iota(xx3) * cos(phd2) ^ 2 - 0.2e1 * Iota(zz3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 - l(c3z) ^ 2 * cos(phd3) ^ 2 - a(2) ^ 2 * cos(phd2) ^ 2) * ddphd1 * Dtheta + (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd3 + dphd2) * sin(phd3) + l(c3z) * (dphd3 / 0.2e1 + dphd2) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd3 + dphd2) * cos(phd3) ^ 2 + (-0.2e1 * l(c3z) * (dphd3 / 0.2e1 + dphd2) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 + dphd3 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd3 + dphd2) * sin(phd3) + dphd2 * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd3 + dphd2)) * m(3) * dphd1 * Dtheta + (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 + (-0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) * m(3) * dphd1 + 0.2e1 * dphd1 * Dtheta * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd2 - 0.2e1 * dphd1 * Dtheta * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) * dphd3) + dphd1 * (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) * a(2) * sin(phd3)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * ddphd2 * Dtheta + 0.2e1 * m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ddphd3 * Dtheta - 0.2e1 * dphd1 ^ 2 * Dtheta * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * Dtheta * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd3 + dphd2) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3) + dphd1 * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ddphd2 * Dtheta + 0.2e1 * m(3) * (Iota(yy3) + l(c3z) ^ 2) * ddphd3 * Dtheta + 0.2e1 * dphd1 ^ 2 * Dtheta * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * Dtheta)) - DDtheta * (-(dddphd1 * Dtheta ^ 2) + 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) ^ 2 / m(3) * (m(3) * (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) * dphd1 * Dtheta + (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * (Dtheta ^ 2) * m(3) * dphd2 - dphd1 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd3) * ((-0.2e1 * (0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) * sin(phd3) * dphd3 + 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3) * cos(phd2) ^ 2 - 0.2e1 * ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) * sin(phd2) * dphd2 - 0.2e1 * sin(phd3) * dphd3 * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3 * sin(phd2) + ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * dphd2) * cos(phd2) - 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * sin(phd2) * dphd2 - 0.2e1 * a(1) * l(c3z) * cos(phd3) * dphd3 * sin(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * cos(phd2) * dphd2 - 0.2e1 * (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3) - 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) / m(3) * (m(3) * (-0.2e1 * sin(phd3) * dphd3 * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * sin(phd3) - (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) * dphd3 + l(c3z) * ((ddphd3 * Dtheta) / 0.2e1 + ddphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 - 0.4e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * cos(phd3) ^ 2 + 0.4e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * ((ddphd3 * Dtheta) / 0.2e1 + ddphd2 * Dtheta) * a(2) * sin(phd3) - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * cos(phd3) * dphd3 + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * ddphd2 * Dtheta + ddphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * cos(phd2) * dphd2 + (-l(c3z) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * sin(phd3) - l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) * dphd3 + ddphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * sin(phd2) * dphd2 - (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) + (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd3) * dphd3 * (dphd2 * Dtheta + dphd3 * Dtheta) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (ddphd2 * Dtheta + (ddphd3 * Dtheta))) * dphd1 * Dtheta + m(3) * (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) * ddphd1 * Dtheta + (-0.2e1 * sin(phd3) * dphd3 * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) ^ 2 * (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 - 0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + ((-0.2e1 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3) * sin(phd2) + ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 - a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) * dphd2 + sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) - cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) * dphd1 * (Dtheta ^ 2) * m(3) * dphd2 + (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * ddphd1 * (Dtheta ^ 2) * m(3) * dphd2 + (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * (Dtheta ^ 2) * m(3) * ddphd2 - ddphd1 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd3 - dphd1 * (Dtheta ^ 2) * m(3) * (sin(phd3) * dphd3 * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 - cos(phd3) ^ 2 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + ((-0.2e1 * (0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) * sin(phd3) * dphd3 + l(c3z) * a(2) * cos(phd3) * dphd3) * sin(phd2) + ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 + a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) * dphd2 - sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) + cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) * dphd3 - dphd1 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * ddphd3) - ddphd1 / dphd3 * (-(ddphd3 * Dtheta ^ 2) - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * sin(phd2) - cos(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity)) + dphd1 / dphd3 ^ 2 * (-(ddphd3 * Dtheta ^ 2) - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * sin(phd2) - cos(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity)) * ddphd3 - dphd1 / dphd3 * (-(dddphd3 * Dtheta ^ 2) + l(c3z) / a(2) * cos(phd3) * dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / m(3) * (-(0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * sin(phd2) - cos(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) + 0.2e1 * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (-(0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * sin(phd2) - cos(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) * dphd3 - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(-0.2e1 * sin(phd3) * dphd3 * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) ^ 2 * (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 - 0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + ((-0.2e1 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3) * sin(phd2) + ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 - a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) * dphd2 + sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) - cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - 0.2e1 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * (Dtheta ^ 2) * m(3) * ddphd1 + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * ddphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * ddphd2 + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (dphd2 * Dtheta + dphd3 * Dtheta) * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * ddphd3 * Dtheta + (-m(3) * l(c3z) * cos(phd3) * dphd3 * sin(phd2) + (-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * cos(phd2) * dphd2 + sin(phd2) * dphd2 * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2)) - cos(phd2) * m(3) * l(c3z) * sin(phd3) * dphd3) * gravity) - 0.2e1 * l(c3z) / a(2) * cos(phd3) * dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity) + 0.2e1 * (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) * dphd3 - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * dphd1 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * ddphd1 + dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (sin(phd3) * dphd3 * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 - cos(phd3) ^ 2 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + ((-0.2e1 * (0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) * sin(phd3) * dphd3 + l(c3z) * a(2) * cos(phd3) * dphd3) * sin(phd2) + ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 + a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) * dphd2 - sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) + cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) - m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 * dphd2 ^ 2 * (Dtheta ^ 2) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 * (Dtheta ^ 2) * ddphd2 + l(c3z) * (-cos(phd2) * dphd2 * sin(phd3) - sin(phd2) * cos(phd3) * dphd3 - sin(phd2) * dphd2 * cos(phd3) - cos(phd2) * sin(phd3) * dphd3) * m(3) * gravity)) - 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) ^ 2 / m(3) * (m(3) * (-l(c3z) ^ 2 * cos(phd2) ^ 2 + Iota(xx3) + 0.2e1 * Iota(zz3) * cos(phd2) * cos(phd3) * sin(phd2) * sin(phd3) - 0.2e1 * Iota(xx3) * cos(phd2) * cos(phd3) * sin(phd2) * sin(phd3) + Iota(zz3) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * sin(phd2) * sin(phd3) * a(1) + 0.2e1 * l(c3z) * cos(phd2) * cos(phd3) * a(1) + 0.2e1 * Iota(xx3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 + a(1) ^ 2 + a(2) ^ 2 - 0.2e1 * l(c3z) ^ 2 * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) + 0.2e1 * l(c3z) ^ 2 * cos(phd2) ^ 2 * cos(phd3) ^ 2 + l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * cos(phd2) * sin(phd2) * cos(phd3) + 0.2e1 * a(2) * sin(phd2) * a(1) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + 0.2e1 * l(c3z) * a(2) * cos(phd2) ^ 2 * sin(phd3) + Iota(zz3) * cos(phd2) ^ 2 - Iota(xx3) * cos(phd3) ^ 2 - Iota(xx3) * cos(phd2) ^ 2 - 0.2e1 * Iota(zz3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 - l(c3z) ^ 2 * cos(phd3) ^ 2 - a(2) ^ 2 * cos(phd2) ^ 2) * ((ddphd1 * Dtheta ^ 2) + dphd1 * h_a) + (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 + (-0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) * m(3) * dphd1 * Dtheta + dphd1 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd2 - dphd1 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) * dphd3) * ((-0.2e1 * (0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) * sin(phd3) * dphd3 + 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3) * cos(phd2) ^ 2 - 0.2e1 * ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) * sin(phd2) * dphd2 - 0.2e1 * sin(phd3) * dphd3 * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3 * sin(phd2) + ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * dphd2) * cos(phd2) - 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * sin(phd2) * dphd2 - 0.2e1 * a(1) * l(c3z) * cos(phd3) * dphd3 * sin(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * cos(phd2) * dphd2 - 0.2e1 * (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3) + 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) / m(3) * (m(3) * (-0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3 + 0.2e1 * l(c3z) ^ 2 * sin(phd3) * cos(phd3) * dphd3 + 0.2e1 * l(c3z) ^ 2 * cos(phd2) * sin(phd2) * dphd2 - 0.2e1 * Iota(zz3) * cos(phd3) * sin(phd3) * dphd3 + 0.2e1 * a(2) * cos(phd2) * dphd2 * a(1) - 0.2e1 * Iota(zz3) * cos(phd2) * sin(phd2) * dphd2 + 0.2e1 * Iota(xx3) * cos(phd3) * sin(phd3) * dphd3 + 0.2e1 * Iota(xx3) * cos(phd2) * sin(phd2) * dphd2 + 0.2e1 * a(2) ^ 2 * cos(phd2) * sin(phd2) * dphd2 - 0.2e1 * l(c3z) * a(2) * cos(phd2) * sin(phd2) * sin(phd3) * dphd3 - 0.4e1 * l(c3z) * a(2) * cos(phd2) * sin(phd3) * sin(phd2) * dphd2 - 0.2e1 * a(1) * l(c3z) * cos(phd3) * dphd3 * sin(phd2) - 0.2e1 * Iota(zz3) * sin(phd2) ^ 2 * dphd2 * cos(phd3) * sin(phd3) - 0.2e1 * Iota(zz3) * cos(phd2) * sin(phd3) ^ 2 * dphd3 * sin(phd2) + 0.2e1 * Iota(xx3) * sin(phd2) ^ 2 * dphd2 * cos(phd3) * sin(phd3) + 0.2e1 * Iota(xx3) * cos(phd2) * sin(phd3) ^ 2 * dphd3 * sin(phd2) - 0.2e1 * l(c3z) * cos(phd2) * dphd2 * sin(phd3) * a(1) - 0.2e1 * l(c3z) * sin(phd2) * dphd2 * cos(phd3) * a(1) - 0.2e1 * l(c3z) * cos(phd2) * sin(phd3) * dphd3 * a(1) - 0.4e1 * Iota(xx3) * cos(phd2) * cos(phd3) ^ 2 * sin(phd2) * dphd2 - 0.4e1 * Iota(xx3) * cos(phd2) ^ 2 * cos(phd3) * sin(phd3) * dphd3 + 0.2e1 * l(c3z) ^ 2 * sin(phd2) ^ 2 * dphd2 * sin(phd3) * cos(phd3) + 0.2e1 * l(c3z) ^ 2 * cos(phd2) * sin(phd3) ^ 2 * sin(phd2) * dphd3 - 0.4e1 * l(c3z) ^ 2 * cos(phd2) * cos(phd3) ^ 2 * sin(phd2) * dphd2 - 0.4e1 * l(c3z) ^ 2 * cos(phd2) ^ 2 * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * sin(phd2) ^ 2 * dphd2 * cos(phd3) + 0.2e1 * l(c3z) * a(2) * cos(phd2) ^ 2 * cos(phd3) * dphd3 + 0.4e1 * Iota(zz3) * cos(phd2) * cos(phd3) ^ 2 * sin(phd2) * dphd2 + 0.4e1 * Iota(zz3) * cos(phd2) ^ 2 * cos(phd3) * sin(phd3) * dphd3 + 0.2e1 * Iota(zz3) * cos(phd2) ^ 2 * cos(phd3) * dphd2 * sin(phd3) + 0.2e1 * Iota(zz3) * cos(phd2) * cos(phd3) ^ 2 * sin(phd2) * dphd3 - 0.2e1 * Iota(xx3) * cos(phd2) ^ 2 * cos(phd3) * dphd2 * sin(phd3) - 0.2e1 * Iota(xx3) * cos(phd2) * cos(phd3) ^ 2 * sin(phd2) * dphd3 - 0.2e1 * l(c3z) ^ 2 * cos(phd2) * cos(phd3) ^ 2 * dphd3 * sin(phd2) - 0.2e1 * l(c3z) ^ 2 * cos(phd2) ^ 2 * sin(phd3) * dphd2 * cos(phd3) + 0.2e1 * l(c3z) * a(2) * cos(phd2) ^ 2 * dphd2 * cos(phd3)) * ((ddphd1 * Dtheta ^ 2) + dphd1 * h_a) + m(3) * (-l(c3z) ^ 2 * cos(phd2) ^ 2 + Iota(xx3) + 0.2e1 * Iota(zz3) * cos(phd2) * cos(phd3) * sin(phd2) * sin(phd3) - 0.2e1 * Iota(xx3) * cos(phd2) * cos(phd3) * sin(phd2) * sin(phd3) + Iota(zz3) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * sin(phd2) * sin(phd3) * a(1) + 0.2e1 * l(c3z) * cos(phd2) * cos(phd3) * a(1) + 0.2e1 * Iota(xx3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 + a(1) ^ 2 + a(2) ^ 2 - 0.2e1 * l(c3z) ^ 2 * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) + 0.2e1 * l(c3z) ^ 2 * cos(phd2) ^ 2 * cos(phd3) ^ 2 + l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * cos(phd2) * sin(phd2) * cos(phd3) + 0.2e1 * a(2) * sin(phd2) * a(1) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + 0.2e1 * l(c3z) * a(2) * cos(phd2) ^ 2 * sin(phd3) + Iota(zz3) * cos(phd2) ^ 2 - Iota(xx3) * cos(phd3) ^ 2 - Iota(xx3) * cos(phd2) ^ 2 - 0.2e1 * Iota(zz3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 - l(c3z) ^ 2 * cos(phd3) ^ 2 - a(2) ^ 2 * cos(phd2) ^ 2) * ((dddphd1 * Dtheta ^ 2) + ddphd1 * h_a + dphd1 * dh_a) + (-0.2e1 * sin(phd3) * dphd3 * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * sin(phd3) - (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) * dphd3 + l(c3z) * ((ddphd3 * Dtheta) / 0.2e1 + ddphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 - 0.4e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + (-0.2e1 * cos(phd2) * dphd2 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * cos(phd3) ^ 2 + 0.4e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) * sin(phd3) * dphd3 + (-0.2e1 * l(c3z) * ((ddphd3 * Dtheta) / 0.2e1 + ddphd2 * Dtheta) * a(2) * sin(phd3) - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * cos(phd3) * dphd3 + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * ddphd2 * Dtheta + ddphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * cos(phd2) * dphd2 + (-l(c3z) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * sin(phd3) - l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) * dphd3 + ddphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 + (-0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * sin(phd2) * dphd2 - (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) + (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd3) * dphd3 * (dphd2 * Dtheta + dphd3 * Dtheta) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (ddphd2 * Dtheta + (ddphd3 * Dtheta))) * m(3) * dphd1 * Dtheta + (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 + (-0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) * m(3) * ddphd1 * Dtheta + ddphd1 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd2 + dphd1 * (Dtheta ^ 2) * m(3) * (-0.2e1 * sin(phd3) * dphd3 * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) ^ 2 * (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 - 0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + (-0.2e1 * cos(phd2) * dphd2 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + 0.4e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3 * sin(phd2) + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 - a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) * dphd2 + sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) - cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) * dphd2 + dphd1 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * ddphd2 - ddphd1 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) * dphd3 - dphd1 * (Dtheta ^ 2) * (sin(phd3) * dphd3 * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 - cos(phd3) ^ 2 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + (0.2e1 * cos(phd2) * dphd2 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 - 0.4e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 + l(c3z) * a(2) * cos(phd3) * dphd3 * sin(phd2) + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * cos(phd2) * dphd2 + a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) * dphd2 - sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) + cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) * m(3) * dphd3 - dphd1 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) * ddphd3) + ddphd1 * (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) * a(2) * sin(phd3)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) - dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta - (sin(phd2) * l(c2x) + cos(phd2) * l(c2y) - a(2) * sin(phd2)) * m(2) * gravity - (l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) - a(2) * sin(phd2)) * m(3) * gravity) + dphd1 * l(c3z) / a(2) * cos(phd3) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / m(3) * (m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) - dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta - (sin(phd2) * l(c2x) + cos(phd2) * l(c2y) - a(2) * sin(phd2)) * m(2) * gravity - (l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) - a(2) * sin(phd2)) * m(3) * gravity) - dphd1 * (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) * a(2) * sin(phd3)) / dphd3 ^ 2 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) - dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta - (sin(phd2) * l(c2x) + cos(phd2) * l(c2y) - a(2) * sin(phd2)) * m(2) * gravity - (l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) - a(2) * sin(phd2)) * m(3) * gravity) * ddphd3 - 0.2e1 * dphd1 * (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) - dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta - (sin(phd2) * l(c2x) + cos(phd2) * l(c2y) - a(2) * sin(phd2)) * m(2) * gravity - (l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) - a(2) * sin(phd2)) * m(3) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) + dphd1 * (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) * a(2) * sin(phd3)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * ((dddphd2 * Dtheta ^ 2) + ddphd2 * h_a + dphd2 * dh_a) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((dddphd3 * Dtheta ^ 2) + ddphd3 * h_a + dphd3 * dh_a) - 0.2e1 * dphd1 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * ddphd1 - dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-0.2e1 * sin(phd3) * dphd3 * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) ^ 2 * (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 - 0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + (-0.2e1 * cos(phd2) * dphd2 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + 0.4e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3 * sin(phd2) + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 - a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) * dphd2 + sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) - cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * ddphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * ddphd2 + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (dphd2 * Dtheta + dphd3 * Dtheta) * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * ddphd3 * Dtheta - (cos(phd2) * dphd2 * l(c2x) - sin(phd2) * dphd2 * l(c2y) - a(2) * cos(phd2) * dphd2) * m(2) * gravity - (l(c3z) * (cos(phd2) * dphd2 * sin(phd3) + sin(phd2) * cos(phd3) * dphd3 + sin(phd2) * dphd2 * cos(phd3) + cos(phd2) * sin(phd3) * dphd3) - a(2) * cos(phd2) * dphd2) * m(3) * gravity) + ddphd1 * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) + dphd1 ^ 2 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) - l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) * m(3) * gravity) - 0.2e1 * dphd1 * l(c3z) / a(2) * cos(phd3) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / m(3) * (m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) + dphd1 ^ 2 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) - l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) * m(3) * gravity) - dphd1 * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) / dphd3 ^ 2 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) + dphd1 ^ 2 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) - l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) * m(3) * gravity) * ddphd3 - 0.2e1 * dphd1 * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) + dphd1 ^ 2 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) - l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) * m(3) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) + dphd1 * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((dddphd2 * Dtheta ^ 2) + ddphd2 * h_a + dphd2 * dh_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * ((dddphd3 * Dtheta ^ 2) + ddphd3 * h_a + dphd3 * dh_a) + 0.2e1 * dphd1 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) * ddphd1 + dphd1 ^ 2 * (Dtheta ^ 2) * (sin(phd3) * dphd3 * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 - cos(phd3) ^ 2 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + (0.2e1 * cos(phd2) * dphd2 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 - 0.4e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 + l(c3z) * a(2) * cos(phd3) * dphd3 * sin(phd2) + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * cos(phd2) * dphd2 + a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) * dphd2 - sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) + cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) * m(3) - m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 * dphd2 ^ 2 * (Dtheta ^ 2) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 * (Dtheta ^ 2) * ddphd2 - l(c3z) * (cos(phd2) * dphd2 * sin(phd3) + sin(phd2) * cos(phd3) * dphd3 + sin(phd2) * dphd2 * cos(phd3) + cos(phd2) * sin(phd3) * dphd3) * m(3) * gravity))) 0 0 -0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) / m(3) * (m(3) * (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) + (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) * dphd2 * Dtheta - m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd3 * Dtheta) - dphd1 / dphd3 * (0.2e1 * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * Dtheta - 0.2e1 * (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 * dphd1 * Dtheta * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)))) 0.2e1 * (-Iota(yy3) - l(c3z) ^ 2) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * Dtheta - 0.2e1 * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 * dphd1 * Dtheta * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - dphd2 / dphd3 * (0.2e1 * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * Dtheta - 0.2e1 * (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 * dphd1 * Dtheta * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)))); 0.1e1 / (2 * Dtheta ^ 2 + 2 * DDtheta ^ 2) * (Dtheta * (-0.2e1 * ddphd2 * Dtheta - (-Iota(yy3) - l(c3z) ^ 2) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-0.2e1 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * Dtheta * m(3) - 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * Dtheta * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd3 + dphd2) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3) - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * dphd1 ^ 2 * Dtheta * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * Dtheta) - dphd2 / dphd3 * (-(2 * ddphd3 * Dtheta) - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-0.2e1 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * Dtheta * m(3) - 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * Dtheta * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd3 + dphd2) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3) - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * dphd1 ^ 2 * Dtheta * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * Dtheta)) + (dphd2 * l(c3z) * a(2) * sin(phd3) - (dphd3 + dphd2) * (Iota(yy3) + l(c3z) ^ 2)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * ddphd2 * Dtheta + 0.2e1 * m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ddphd3 * Dtheta - 0.2e1 * dphd1 ^ 2 * Dtheta * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * Dtheta * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd3 + dphd2) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3) + (-0.2e1 * l(c3z) * (dphd3 / 0.2e1 + dphd2) * a(2) * sin(phd3) + (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2) * dphd2 + dphd3 * (Iota(yy3) + l(c3z) ^ 2)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ddphd2 * Dtheta + 0.2e1 * m(3) * (Iota(yy3) + l(c3z) ^ 2) * ddphd3 * Dtheta + 0.2e1 * dphd1 ^ 2 * Dtheta * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * Dtheta)) - DDtheta * (-(dddphd2 * Dtheta ^ 2) + 0.2e1 * (-Iota(yy3) - l(c3z) ^ 2) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (-(0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * sin(phd2) - cos(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) * dphd3 - (-Iota(yy3) - l(c3z) ^ 2) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(-0.2e1 * sin(phd3) * dphd3 * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) ^ 2 * (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 - 0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + ((-0.2e1 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3) * sin(phd2) + ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 - a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) * dphd2 + sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) - cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - 0.2e1 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * (Dtheta ^ 2) * m(3) * ddphd1 + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * ddphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * ddphd2 + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (dphd2 * Dtheta + dphd3 * Dtheta) * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * ddphd3 * Dtheta + (-m(3) * l(c3z) * cos(phd3) * dphd3 * sin(phd2) + (-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * cos(phd2) * dphd2 + sin(phd2) * dphd2 * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2)) - cos(phd2) * m(3) * l(c3z) * sin(phd3) * dphd3) * gravity) + l(c3z) / a(2) * cos(phd3) * dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity) + 0.2e1 * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) * dphd3 - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * dphd1 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * ddphd1 + dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (sin(phd3) * dphd3 * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 - cos(phd3) ^ 2 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + ((-0.2e1 * (0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) * sin(phd3) * dphd3 + l(c3z) * a(2) * cos(phd3) * dphd3) * sin(phd2) + ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 + a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) * dphd2 - sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) + cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) - m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 * dphd2 ^ 2 * (Dtheta ^ 2) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 * (Dtheta ^ 2) * ddphd2 + l(c3z) * (-cos(phd2) * dphd2 * sin(phd3) - sin(phd2) * cos(phd3) * dphd3 - sin(phd2) * dphd2 * cos(phd3) - cos(phd2) * sin(phd3) * dphd3) * m(3) * gravity) - ddphd2 / dphd3 * (-(ddphd3 * Dtheta ^ 2) - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * sin(phd2) - cos(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity)) + dphd2 / dphd3 ^ 2 * (-(ddphd3 * Dtheta ^ 2) - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * sin(phd2) - cos(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity)) * ddphd3 - dphd2 / dphd3 * (-(dddphd3 * Dtheta ^ 2) + l(c3z) / a(2) * cos(phd3) * dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / m(3) * (-(0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * sin(phd2) - cos(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) + 0.2e1 * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (-(0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * sin(phd2) - cos(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) * dphd3 - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(-0.2e1 * sin(phd3) * dphd3 * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) ^ 2 * (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 - 0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + ((-0.2e1 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3) * sin(phd2) + ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 - a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) * dphd2 + sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) - cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) - 0.2e1 * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * (Dtheta ^ 2) * m(3) * ddphd1 + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * ddphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * ddphd2 + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (dphd2 * Dtheta + dphd3 * Dtheta) * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * ddphd3 * Dtheta + (-m(3) * l(c3z) * cos(phd3) * dphd3 * sin(phd2) + (-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * cos(phd2) * dphd2 + sin(phd2) * dphd2 * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2)) - cos(phd2) * m(3) * l(c3z) * sin(phd3) * dphd3) * gravity) - 0.2e1 * l(c3z) / a(2) * cos(phd3) * dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity) + 0.2e1 * (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) + l(c3z) * (-sin(phd2) * sin(phd3) + cos(phd2) * cos(phd3)) * m(3) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) * dphd3 - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (0.2e1 * dphd1 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * ddphd1 + dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (sin(phd3) * dphd3 * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 - cos(phd3) ^ 2 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + ((-0.2e1 * (0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) * sin(phd3) * dphd3 + l(c3z) * a(2) * cos(phd3) * dphd3) * sin(phd2) + ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 + a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) * dphd2 - sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) + cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) - m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 * dphd2 ^ 2 * (Dtheta ^ 2) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 * (Dtheta ^ 2) * ddphd2 + l(c3z) * (-cos(phd2) * dphd2 * sin(phd3) - sin(phd2) * cos(phd3) * dphd3 - sin(phd2) * dphd2 * cos(phd3) - cos(phd2) * sin(phd3) * dphd3) * m(3) * gravity)) + (ddphd2 * l(c3z) * a(2) * sin(phd3) + dphd2 * l(c3z) * a(2) * cos(phd3) * dphd3 - (ddphd3 + ddphd2) * (Iota(yy3) + l(c3z) ^ 2)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) - dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta - (sin(phd2) * l(c2x) + cos(phd2) * l(c2y) - a(2) * sin(phd2)) * m(2) * gravity - (l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) - a(2) * sin(phd2)) * m(3) * gravity) - (dphd2 * l(c3z) * a(2) * sin(phd3) - (dphd3 + dphd2) * (Iota(yy3) + l(c3z) ^ 2)) / dphd3 ^ 2 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) - dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta - (sin(phd2) * l(c2x) + cos(phd2) * l(c2y) - a(2) * sin(phd2)) * m(2) * gravity - (l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) - a(2) * sin(phd2)) * m(3) * gravity) * ddphd3 - 0.2e1 * (dphd2 * l(c3z) * a(2) * sin(phd3) - (dphd3 + dphd2) * (Iota(yy3) + l(c3z) ^ 2)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) - dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * dphd3 * Dtheta - (sin(phd2) * l(c2x) + cos(phd2) * l(c2y) - a(2) * sin(phd2)) * m(2) * gravity - (l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) - a(2) * sin(phd2)) * m(3) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) + (dphd2 * l(c3z) * a(2) * sin(phd3) - (dphd3 + dphd2) * (Iota(yy3) + l(c3z) ^ 2)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * ((dddphd2 * Dtheta ^ 2) + ddphd2 * h_a + dphd2 * dh_a) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((dddphd3 * Dtheta ^ 2) + ddphd3 * h_a + dphd3 * dh_a) - 0.2e1 * dphd1 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * ddphd1 - dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (-0.2e1 * sin(phd3) * dphd3 * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) ^ 2 * (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 - 0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + (-0.2e1 * cos(phd2) * dphd2 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + 0.4e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 - 0.2e1 * l(c3z) * a(2) * cos(phd3) * dphd3 * sin(phd2) + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) * dphd2 - a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) * dphd2 + sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) - cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * ddphd3 * (Dtheta ^ 2) * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (Dtheta ^ 2) * ddphd2 + m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 ^ 2 * (dphd2 * Dtheta + dphd3 * Dtheta) * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (ddphd2 * Dtheta + (ddphd3 * Dtheta)) * dphd3 * Dtheta - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta) * ddphd3 * Dtheta - (cos(phd2) * dphd2 * l(c2x) - sin(phd2) * dphd2 * l(c2y) - a(2) * cos(phd2) * dphd2) * m(2) * gravity - (l(c3z) * (cos(phd2) * dphd2 * sin(phd3) + sin(phd2) * cos(phd3) * dphd3 + sin(phd2) * dphd2 * cos(phd3) + cos(phd2) * sin(phd3) * dphd3) - a(2) * cos(phd2) * dphd2) * m(3) * gravity) + (-0.2e1 * l(c3z) * (ddphd3 / 0.2e1 + ddphd2) * a(2) * sin(phd3) - 0.2e1 * l(c3z) * (dphd3 / 0.2e1 + dphd2) * a(2) * cos(phd3) * dphd3 + (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2) * ddphd2 + ddphd3 * (Iota(yy3) + l(c3z) ^ 2)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) + dphd1 ^ 2 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) - l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) * m(3) * gravity) - (-0.2e1 * l(c3z) * (dphd3 / 0.2e1 + dphd2) * a(2) * sin(phd3) + (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2) * dphd2 + dphd3 * (Iota(yy3) + l(c3z) ^ 2)) / dphd3 ^ 2 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) + dphd1 ^ 2 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) - l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) * m(3) * gravity) * ddphd3 - 0.2e1 * (-0.2e1 * l(c3z) * (dphd3 / 0.2e1 + dphd2) * a(2) * sin(phd3) + (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2) * dphd2 + dphd3 * (Iota(yy3) + l(c3z) ^ 2)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) ^ 2 / a(2) ^ 2 / m(3) * (m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * ((ddphd3 * Dtheta ^ 2) + dphd3 * h_a) + dphd1 ^ 2 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * (Dtheta ^ 2) - l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) * m(3) * gravity) * l(c3z) ^ 2 * sin(phd3) * cos(phd3) + (-0.2e1 * l(c3z) * (dphd3 / 0.2e1 + dphd2) * a(2) * sin(phd3) + (Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2) * dphd2 + dphd3 * (Iota(yy3) + l(c3z) ^ 2)) / dphd3 / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * (ddphd2 * (Dtheta ^ 2) + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) * ((dddphd2 * Dtheta ^ 2) + ddphd2 * h_a + dphd2 * dh_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * ((dddphd3 * Dtheta ^ 2) + ddphd3 * h_a + dphd3 * dh_a) + 0.2e1 * dphd1 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) * ddphd1 + dphd1 ^ 2 * (Dtheta ^ 2) * (sin(phd3) * dphd3 * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 - cos(phd3) ^ 2 * (0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * dphd3 * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) * dphd2 + (0.2e1 * cos(phd2) * dphd2 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 - 0.4e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) * sin(phd3) * dphd3 + l(c3z) * a(2) * cos(phd3) * dphd3 * sin(phd2) + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * cos(phd2) * dphd2 + a(1) * l(c3z) * cos(phd3) * dphd3) * cos(phd2) - (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) * dphd2 - sin(phd3) * dphd3 * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) + cos(phd3) * (l(c3z) * cos(phd2) * dphd2 * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) * dphd3)) * m(3) - m(3) * l(c3z) * a(2) * sin(phd3) * dphd3 * dphd2 ^ 2 * (Dtheta ^ 2) + 0.2e1 * m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 * (Dtheta ^ 2) * ddphd2 - l(c3z) * (cos(phd2) * dphd2 * sin(phd3) + sin(phd2) * cos(phd3) * dphd3 + sin(phd2) * dphd2 * cos(phd3) + cos(phd2) * sin(phd3) * dphd3) * m(3) * gravity))) 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) ^ 2 / m(3) * (m(3) * (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) * dphd1 * Dtheta + (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * (Dtheta ^ 2) * m(3) * dphd2 - dphd1 * (Dtheta ^ 2) * m(3) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd3) * (-0.2e1 * ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) * sin(phd2) + 0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 - 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * sin(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * cos(phd2)) - 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) / m(3) * (m(3) * (-0.4e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) * sin(phd2) + (-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * cos(phd2) ^ 2 - ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * sin(phd2) - l(c3z) * cos(phd2) * a(1) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) * dphd1 * Dtheta + (-0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) + ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) ^ 2 - (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) - l(c3z) * cos(phd2) * cos(phd3) * a(1)) * dphd1 * (Dtheta ^ 2) * m(3) * dphd2 - dphd1 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) + ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * cos(phd2) ^ 2 - (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) + l(c3z) * cos(phd2) * cos(phd3) * a(1)) * dphd3) - dphd1 / dphd3 * (-(Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(-0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) + ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) ^ 2 - (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) - l(c3z) * cos(phd2) * cos(phd3) * a(1)) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * cos(phd2) + sin(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) + ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * cos(phd2) ^ 2 - (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) + l(c3z) * cos(phd2) * cos(phd3) * a(1)) + l(c3z) * (-cos(phd2) * sin(phd3) - cos(phd3) * sin(phd2)) * m(3) * gravity)) - 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) ^ 2 / m(3) * (m(3) * (-l(c3z) ^ 2 * cos(phd2) ^ 2 + Iota(xx3) + 0.2e1 * Iota(zz3) * cos(phd2) * cos(phd3) * sin(phd2) * sin(phd3) - 0.2e1 * Iota(xx3) * cos(phd2) * cos(phd3) * sin(phd2) * sin(phd3) + Iota(zz3) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * sin(phd2) * sin(phd3) * a(1) + 0.2e1 * l(c3z) * cos(phd2) * cos(phd3) * a(1) + 0.2e1 * Iota(xx3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 + a(1) ^ 2 + a(2) ^ 2 - 0.2e1 * l(c3z) ^ 2 * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) + 0.2e1 * l(c3z) ^ 2 * cos(phd2) ^ 2 * cos(phd3) ^ 2 + l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * cos(phd2) * sin(phd2) * cos(phd3) + 0.2e1 * a(2) * sin(phd2) * a(1) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + 0.2e1 * l(c3z) * a(2) * cos(phd2) ^ 2 * sin(phd3) + Iota(zz3) * cos(phd2) ^ 2 - Iota(xx3) * cos(phd3) ^ 2 - Iota(xx3) * cos(phd2) ^ 2 - 0.2e1 * Iota(zz3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 - l(c3z) ^ 2 * cos(phd3) ^ 2 - a(2) ^ 2 * cos(phd2) ^ 2) * ((ddphd1 * Dtheta ^ 2) + dphd1 * h_a) + (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * (dphd2 * Dtheta + dphd3 * Dtheta) * cos(phd3) ^ 2 + (-0.2e1 * l(c3z) * (dphd3 * Dtheta / 0.2e1 + dphd2 * Dtheta) * a(2) * sin(phd3) + (l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * dphd2 * Dtheta + dphd3 * Dtheta * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2)) * sin(phd2) + (-l(c3z) * (dphd2 * Dtheta + dphd3 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2)) * a(1)) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (dphd2 * Dtheta + dphd3 * Dtheta)) * m(3) * dphd1 * Dtheta + dphd1 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd2 - dphd1 * (Dtheta ^ 2) * (-cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 + (-Iota(xx3) + l(c3z) * a(2) * sin(phd3) + Iota(zz3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * m(3) * dphd3) * (-0.2e1 * ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) * sin(phd2) + 0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 - 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * sin(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * cos(phd2)) -(-Iota(yy3) - l(c3z) ^ 2) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(-0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) + ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) ^ 2 - (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) - l(c3z) * cos(phd2) * cos(phd3) * a(1)) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * cos(phd2) + sin(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) - (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) + ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * cos(phd2) ^ 2 - (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) + l(c3z) * cos(phd2) * cos(phd3) * a(1)) + l(c3z) * (-cos(phd2) * sin(phd3) - cos(phd3) * sin(phd2)) * m(3) * gravity) - dphd2 / dphd3 * (-(Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (-(-0.4e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) + ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * cos(phd2) ^ 2 - (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * sin(phd2) - l(c3z) * cos(phd2) * cos(phd3) * a(1)) * dphd1 ^ 2 * (Dtheta ^ 2) * m(3) + ((-m(3) * l(c3z) * sin(phd3) + (-l(c2x) + a(2)) * m(2) + m(3) * a(2)) * cos(phd2) + sin(phd2) * (-m(3) * l(c3z) * cos(phd3) + l(c2y) * m(2))) * gravity) - (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) ^ 2 / m(3) * (dphd1 ^ 2 * (Dtheta ^ 2) * m(3) * (0.2e1 * cos(phd3) * ((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) * sin(phd2) + ((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * cos(phd2) ^ 2 - (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 + Iota(zz3) - l(c3z) ^ 2 - Iota(xx3) + l(c3z) * a(2) * sin(phd3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * sin(phd2) + l(c3z) * cos(phd2) * cos(phd3) * a(1)) + l(c3z) * (-cos(phd2) * sin(phd3) - cos(phd3) * sin(phd2)) * m(3) * gravity)) -0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) / m(3) * (m(3) * (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + ((-0.2e1 * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3) + l(c3z) ^ 2 - Iota(zz3) + a(2) ^ 2 + Iota(xx3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * Dtheta + (0.2e1 * cos(phd3) * ((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (((0.2e1 * Iota(zz3) - 0.2e1 * Iota(xx3) - 0.2e1 * l(c3z) ^ 2) * cos(phd3) ^ 2 + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3) + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3)) * sin(phd2) + a(1) * (-l(c3z) * sin(phd3) + a(2))) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * Dtheta * m(3)) - dphd1 / dphd3 * (0.2e1 * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) * l(c3z) * cos(phd3) * dphd3 * Dtheta - 0.2e1 * (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) * l(c3z) * cos(phd3) * dphd2 * Dtheta) + 0.1e1 / (((0.2e1 * Iota(xx3) + 0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(zz3)) * cos(phd3) ^ 2 - l(c3z) ^ 2 - Iota(xx3) + 0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(zz3) - a(2) ^ 2) * cos(phd2) ^ 2 + 0.2e1 * cos(phd3) * (((Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * sin(phd2) + l(c3z) * a(1)) * cos(phd2) + 0.2e1 * a(1) * (-l(c3z) * sin(phd3) + a(2)) * sin(phd2) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * cos(phd3) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + a(1) ^ 2 + l(c3z) ^ 2 + a(2) ^ 2) * (0.2e1 * cos(phd3) * (-(-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (-Iota(zz3) + Iota(xx3) + l(c3z) ^ 2) * cos(phd3) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3) * sin(phd2) - l(c3z) * sin(phd3) * a(1)) * cos(phd2) - cos(phd3) * (l(c3z) * sin(phd2) * a(1) + (Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd3) + l(c3z) * a(2))) * dphd1 * Dtheta - dphd1 * (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) * l(c3z) * cos(phd3) * Dtheta 0.2e1 * (-Iota(yy3) - l(c3z) ^ 2) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) * l(c3z) * cos(phd3) * dphd3 * Dtheta - 0.2e1 * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) * l(c3z) * cos(phd3) * dphd2 * Dtheta - dphd2 / dphd3 * (0.2e1 * (Iota(yy3) + l(c3z) ^ 2 - l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) * l(c3z) * cos(phd3) * dphd3 * Dtheta - 0.2e1 * (-Iota(yy3) - a(2) ^ 2 - l(c3z) ^ 2 + 0.2e1 * l(c3z) * a(2) * sin(phd3)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) * l(c3z) * cos(phd3) * dphd2 * Dtheta) - (dphd2 * l(c3z) * a(2) * sin(phd3) - (dphd3 + dphd2) * (Iota(yy3) + l(c3z) ^ 2)) / (-Iota(yy3) - l(c3z) ^ 2 + l(c3z) ^ 2 * sin(phd3) ^ 2) / a(2) * l(c3z) * cos(phd3) * Dtheta;];
end
