function [u,U] = feedbacktransformation(q, v, theta)

%t = get_time(theta);
Dtheta = DTheta(theta);
DDtheta = DDTheta(theta);

global a d g gravity m1 m2 m3 m load c1x c2x c2y c3z 
global l r1 r2 r3 h1 h2 h3 xx1 xx2 xx3 yy1 yy2 yy3 zz1 zz2 zz3
global Iota xxl yyl zzl x y z Kd1 Kd2 Kd3 Kp1 Kp2 Kp3

phd1 = phi1(theta);
phd2 = phi2(theta);
phd3 = phi3(theta);

dphd1 = dphi1(theta);
dphd2 = dphi2(theta);
dphd3 = dphi3(theta);

ddphd1 = ddphi1(theta);
ddphd2 = ddphi2(theta);
ddphd3 = ddphi3(theta);

%U = [m(3) * (Iota(xx3) + a(1) ^ 2 + a(2) ^ 2 - a(2) ^ 2 * cos(phi2(theta)) ^ 2 + 0.2e1 * a(2) * sin(phi2(theta)) * a(1) - 0.2e1 * l(c3z) ^ 2 * cos(phi2(theta)) * sin(phi3(theta)) * sin(phi2(theta)) * cos(phi3(theta)) + 0.2e1 * l(c3z) ^ 2 * cos(phi2(theta)) ^ 2 * cos(phi3(theta)) ^ 2 + l(c3z) ^ 2 - l(c3z) ^ 2 * cos(phi2(theta)) ^ 2 - l(c3z) ^ 2 * cos(phi3(theta)) ^ 2 + 0.2e1 * l(c3z) * a(2) * cos(phi2(theta)) * sin(phi2(theta)) * cos(phi3(theta)) - 0.2e1 * l(c3z) * a(2) * sin(phi3(theta)) + 0.2e1 * l(c3z) * a(2) * cos(phi2(theta)) ^ 2 * sin(phi3(theta)) - 0.2e1 * Iota(xx3) * cos(phi2(theta)) * sin(phi3(theta)) * sin(phi2(theta)) * cos(phi3(theta)) + 0.2e1 * Iota(zz3) * cos(phi2(theta)) * sin(phi3(theta)) * sin(phi2(theta)) * cos(phi3(theta)) - 0.2e1 * l(c3z) * sin(phi2(theta)) * sin(phi3(theta)) * a(1) + 0.2e1 * l(c3z) * cos(phi2(theta)) * cos(phi3(theta)) * a(1) + 0.2e1 * Iota(xx3) * cos(phi2(theta)) ^ 2 * cos(phi3(theta)) ^ 2 - Iota(xx3) * cos(phi3(theta)) ^ 2 - Iota(xx3) * cos(phi2(theta)) ^ 2 + Iota(zz3) * cos(phi3(theta)) ^ 2 - 0.2e1 * Iota(zz3) * cos(phi3(theta)) ^ 2 * cos(phi2(theta)) ^ 2 + Iota(zz3) * cos(phi2(theta)) ^ 2) * (ddphi1(theta) * h_v ^ 2 + dphi1(theta) * h_a) + (0.2e1 * cos(phi3(theta)) * (-(l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * (Dy3 + dphi3(theta) * Dtheta + Dy2 + dphi2(theta) * Dtheta) * sin(phi3(theta)) + (Dy2 + dphi2(theta) * Dtheta + Dy3 / 0.2e1 + dphi3(theta) * Dtheta / 0.2e1) * a(2) * l(c3z)) * cos(phi2(theta)) ^ 2 + (-0.2e1 * sin(phi2(theta)) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * (Dy3 + dphi3(theta) * Dtheta + Dy2 + dphi2(theta) * Dtheta) * cos(phi3(theta)) ^ 2 + (-0.2e1 * (Dy2 + dphi2(theta) * Dtheta + Dy3 / 0.2e1 + dphi3(theta) * Dtheta / 0.2e1) * a(2) * l(c3z) * sin(phi3(theta)) + (Iota(xx3) + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3)) * dphi2(theta) * h_v + dphi3(theta) * h_v * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3))) * sin(phi2(theta)) + a(1) * (-l(c3z) * (Dy3 + dphi3(theta) * Dtheta + Dy2 + dphi2(theta) * Dtheta) * sin(phi3(theta)) + dphi2(theta) * h_v * a(2))) * cos(phi2(theta)) - (l(c3z) * sin(phi2(theta)) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phi3(theta)) + l(c3z) * a(2)) * cos(phi3(theta)) * (Dy3 + dphi3(theta) * Dtheta + Dy2 + dphi2(theta) * Dtheta)) * m(3) * dphi1(theta) * Dtheta + m(3) * dphi1(theta) * Dtheta * (0.2e1 * ((-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phi3(theta)) + l(c3z) * a(2)) * cos(phi3(theta)) * cos(phi2(theta)) ^ 2 + (-0.2e1 * sin(phi2(theta)) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phi3(theta)) ^ 2 + (a(2) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phi3(theta)) + l(c3z) ^ 2 - Iota(zz3)) * sin(phi2(theta)) + a(1) * (a(2) - l(c3z) * sin(phi3(theta)))) * cos(phi2(theta)) - (l(c3z) * sin(phi2(theta)) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phi3(theta)) + l(c3z) * a(2)) * cos(phi3(theta))) * dphi2(theta) * h_v - m(3) * (-((-0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(xx3) + 0.2e1 * Iota(zz3)) * sin(phi3(theta)) + l(c3z) * a(2)) * cos(phi3(theta)) * cos(phi2(theta)) ^ 2 + (0.2e1 * sin(phi2(theta)) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phi3(theta)) ^ 2 + (l(c3z) * a(2) * sin(phi3(theta)) + Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phi2(theta)) + l(c3z) * sin(phi3(theta)) * a(1)) * cos(phi2(theta)) + (l(c3z) * sin(phi2(theta)) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phi3(theta)) + l(c3z) * a(2)) * cos(phi3(theta))) * dphi1(theta) * Dtheta * dphi3(theta) * h_v m(3) * (-0.2e1 * l(c3z) * a(2) * sin(phi3(theta)) + Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2) * (ddphi2(theta) * h_v ^ 2 + dphi2(theta) * h_a) + m(3) * (-l(c3z) * a(2) * sin(phi3(theta)) + Iota(yy3) + l(c3z) ^ 2) * (ddphi3(theta) * h_v ^ 2 + dphi3(theta) * h_a) - m(3) * dphi1(theta) ^ 2 * Dtheta ^ 2 * (0.2e1 * ((-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phi3(theta)) + l(c3z) * a(2)) * cos(phi3(theta)) * cos(phi2(theta)) ^ 2 + (-0.2e1 * sin(phi2(theta)) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phi3(theta)) ^ 2 + (a(2) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phi3(theta)) + l(c3z) ^ 2 - Iota(zz3)) * sin(phi2(theta)) + a(1) * (a(2) - l(c3z) * sin(phi3(theta)))) * cos(phi2(theta)) - (l(c3z) * sin(phi2(theta)) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phi3(theta)) + l(c3z) * a(2)) * cos(phi3(theta))) - m(3) * l(c3z) * a(2) * cos(phi3(theta)) * dphi3(theta) * h_v ^ 2 * dphi2(theta) - m(3) * l(c3z) * a(2) * cos(phi3(theta)) * (Dy3 + dphi3(theta) * Dtheta + Dy2 + dphi2(theta) * Dtheta) * dphi3(theta) * h_v - (sin(phi2(theta)) * l(c2x) + cos(phi2(theta)) * l(c2y) - a(2) * sin(phi2(theta))) * m(2) * gravity - (l(c3z) * (sin(phi2(theta)) * sin(phi3(theta)) - cos(phi2(theta)) * cos(phi3(theta))) - a(2) * sin(phi2(theta))) * m(3) * gravity m(3) * (-l(c3z) * a(2) * sin(phi3(theta)) + Iota(yy3) + l(c3z) ^ 2) * (ddphi2(theta) * h_v ^ 2 + dphi2(theta) * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * (ddphi3(theta) * h_v ^ 2 + dphi3(theta) * h_a) + m(3) * (-((-0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(xx3) + 0.2e1 * Iota(zz3)) * sin(phi3(theta)) + l(c3z) * a(2)) * cos(phi3(theta)) * cos(phi2(theta)) ^ 2 + (0.2e1 * sin(phi2(theta)) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phi3(theta)) ^ 2 + (l(c3z) * a(2) * sin(phi3(theta)) + Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phi2(theta)) + l(c3z) * sin(phi3(theta)) * a(1)) * cos(phi2(theta)) + (l(c3z) * sin(phi2(theta)) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phi3(theta)) + l(c3z) * a(2)) * cos(phi3(theta))) * dphi1(theta) ^ 2 * Dtheta ^ 2 + m(3) * l(c3z) * a(2) * cos(phi3(theta)) * dphi2(theta) ^ 2 * h_v ^ 2 - l(c3z) * (sin(phi2(theta)) * sin(phi3(theta)) - cos(phi2(theta)) * cos(phi3(theta))) * m(3) * gravity]';

h_v = Dtheta;
h_a = DDtheta*Dtheta;

Dy1 = 0;Dy2 = 0;Dy3 = 0;

%U = [m(3) * (Iota(xx3) + a(1) ^ 2 - a(2) ^ 2 * cos(phd2) ^ 2 + a(2) ^ 2 + 0.2e1 * a(2) * sin(phd2) * a(1) - 0.2e1 * l(c3z) ^ 2 * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) + 0.2e1 * l(c3z) ^ 2 * cos(phd2) ^ 2 * cos(phd3) ^ 2 + l(c3z) ^ 2 - l(c3z) ^ 2 * cos(phd2) ^ 2 - l(c3z) ^ 2 * cos(phd3) ^ 2 + 0.2e1 * l(c3z) * a(2) * cos(phd2) * sin(phd2) * cos(phd3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + 0.2e1 * l(c3z) * a(2) * cos(phd2) ^ 2 * sin(phd3) - 0.2e1 * l(c3z) * sin(phd2) * sin(phd3) * a(1) + 0.2e1 * l(c3z) * cos(phd2) * cos(phd3) * a(1) - 0.2e1 * Iota(xx3) * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) + 0.2e1 * Iota(zz3) * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) + 0.2e1 * Iota(xx3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 + Iota(zz3) * cos(phd3) ^ 2 - 0.2e1 * Iota(zz3) * cos(phd3) ^ 2 * cos(phd2) ^ 2 + Iota(zz3) * cos(phd2) ^ 2 - Iota(xx3) * cos(phd3) ^ 2 - Iota(xx3) * cos(phd2) ^ 2) * (ddphd1 * Dtheta ^ 2 + dphd1 * DDtheta) + (0.2e1 * cos(phd3) * (-(l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * (dphd3 * Dtheta + dphd2 * Dtheta) * sin(phd3) + l(c3z) * a(2) * (dphd2 * Dtheta + dphd3 * Dtheta / 0.2e1)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * (dphd3 * Dtheta + dphd2 * Dtheta) * cos(phd3) ^ 2 + (-0.2e1 * l(c3z) * a(2) * (dphd2 * Dtheta + dphd3 * Dtheta / 0.2e1) * sin(phd3) + (-Iota(zz3) + l(c3z) ^ 2 + Iota(xx3) + a(2) ^ 2) * dphd2 * Dtheta + dphd3 * Dtheta * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3))) * sin(phd2) + a(1) * (-l(c3z) * (dphd3 * Dtheta + dphd2 * Dtheta) * sin(phd3) + dphd2 * Dtheta * a(2))) * cos(phd2) - cos(phd3) * (dphd3 * Dtheta + dphd2 * Dtheta) * (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2))) * m(3) * dphd1 * Dtheta + (0.2e1 * ((-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phd3) ^ 2 + (l(c3z) ^ 2 + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3) - Iota(zz3) + Iota(xx3)) * sin(phd2) + a(1) * (a(2) - l(c3z) * sin(phd3))) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3)) * dphd1 * Dtheta ^ 2 * m(3) * dphd2 - dphd1 * Dtheta ^ 2 * m(3) * (-((-0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(xx3) + 0.2e1 * Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phd3) ^ 2 + (-Iota(xx3) - l(c3z) ^ 2 + l(c3z) * a(2) * sin(phd3) + Iota(zz3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3)) * dphd3 m(3) * (Iota(yy3) + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3) + l(c3z) ^ 2) * (ddphd2 * Dtheta ^ 2 + dphd2 * DDtheta) + m(3) * (Iota(yy3) - l(c3z) * a(2) * sin(phd3) + l(c3z) ^ 2) * (ddphd3 * Dtheta ^ 2 + dphd3 * DDtheta) - (0.2e1 * ((-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phd3) ^ 2 + (l(c3z) ^ 2 + a(2) ^ 2 - 0.2e1 * l(c3z) * a(2) * sin(phd3) - Iota(zz3) + Iota(xx3)) * sin(phd2) + a(1) * (a(2) - l(c3z) * sin(phd3))) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3)) * dphd1 ^ 2 * Dtheta ^ 2 * m(3) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * Dtheta ^ 2 * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (dphd3 * Dtheta + dphd2 * Dtheta) * dphd3 * Dtheta - (sin(phd2) * l(c2x) + cos(phd2) * l(c2y) - a(2) * sin(phd2)) * m(2) * gravity - (l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) - a(2) * sin(phd2)) * m(3) * gravity m(3) * (Iota(yy3) - l(c3z) * a(2) * sin(phd3) + l(c3z) ^ 2) * (ddphd2 * Dtheta ^ 2 + dphd2 * DDtheta) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * (ddphd3 * Dtheta ^ 2 + dphd3 * DDtheta) + dphd1 ^ 2 * Dtheta ^ 2 * m(3) * (-((-0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(xx3) + 0.2e1 * Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phd3) ^ 2 + (-Iota(xx3) - l(c3z) ^ 2 + l(c3z) * a(2) * sin(phd3) + Iota(zz3)) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3)) + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * Dtheta ^ 2 - l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) * m(3) * gravity]';
U = [m(3) * (Iota(xx3) + a(1) ^ 2 + a(2) ^ 2 - a(2) ^ 2 * cos(phd2) ^ 2 + 0.2e1 * a(2) * sin(phd2) * a(1) - 0.2e1 * l(c3z) ^ 2 * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) + 0.2e1 * l(c3z) ^ 2 * cos(phd2) ^ 2 * cos(phd3) ^ 2 + l(c3z) ^ 2 - l(c3z) ^ 2 * cos(phd2) ^ 2 - l(c3z) ^ 2 * cos(phd3) ^ 2 + 0.2e1 * l(c3z) * a(2) * cos(phd2) * sin(phd2) * cos(phd3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + 0.2e1 * l(c3z) * a(2) * cos(phd2) ^ 2 * sin(phd3) - 0.2e1 * Iota(xx3) * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) + 0.2e1 * Iota(zz3) * cos(phd2) * sin(phd3) * sin(phd2) * cos(phd3) - 0.2e1 * l(c3z) * sin(phd2) * sin(phd3) * a(1) + 0.2e1 * l(c3z) * cos(phd2) * cos(phd3) * a(1) + 0.2e1 * Iota(xx3) * cos(phd2) ^ 2 * cos(phd3) ^ 2 - Iota(xx3) * cos(phd3) ^ 2 - Iota(xx3) * cos(phd2) ^ 2 + Iota(zz3) * cos(phd3) ^ 2 - 0.2e1 * Iota(zz3) * cos(phd3) ^ 2 * cos(phd2) ^ 2 + Iota(zz3) * cos(phd2) ^ 2) * (ddphd1 * h_v ^ 2 + dphd1 * h_a) + (0.2e1 * cos(phd3) * (-(l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * (Dy3 + dphd3 * Dtheta + Dy2 + dphd2 * Dtheta) * sin(phd3) + (Dy2 + dphd2 * Dtheta + Dy3 / 0.2e1 + dphd3 * Dtheta / 0.2e1) * a(2) * l(c3z)) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * (Dy3 + dphd3 * Dtheta + Dy2 + dphd2 * Dtheta) * cos(phd3) ^ 2 + (-0.2e1 * (Dy2 + dphd2 * Dtheta + Dy3 / 0.2e1 + dphd3 * Dtheta / 0.2e1) * a(2) * l(c3z) * sin(phd3) + (Iota(xx3) + a(2) ^ 2 + l(c3z) ^ 2 - Iota(zz3)) * dphd2 * h_v + dphd3 * h_v * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3))) * sin(phd2) + a(1) * (-l(c3z) * (Dy3 + dphd3 * Dtheta + Dy2 + dphd2 * Dtheta) * sin(phd3) + dphd2 * h_v * a(2))) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * (Dy3 + dphd3 * Dtheta + Dy2 + dphd2 * Dtheta)) * m(3) * dphd1 * Dtheta + m(3) * dphd1 * Dtheta * (0.2e1 * ((-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phd3) ^ 2 + (a(2) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + l(c3z) ^ 2 - Iota(zz3)) * sin(phd2) + a(1) * (a(2) - l(c3z) * sin(phd3))) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3)) * dphd2 * h_v - m(3) * (-((-0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(xx3) + 0.2e1 * Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phd3) ^ 2 + (l(c3z) * a(2) * sin(phd3) + Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3)) * dphd1 * Dtheta * dphd3 * h_v m(3) * (-0.2e1 * l(c3z) * a(2) * sin(phd3) + Iota(yy3) + a(2) ^ 2 + l(c3z) ^ 2) * (ddphd2 * h_v ^ 2 + dphd2 * h_a) + m(3) * (-l(c3z) * a(2) * sin(phd3) + Iota(yy3) + l(c3z) ^ 2) * (ddphd3 * h_v ^ 2 + dphd3 * h_a) - m(3) * dphd1 ^ 2 * Dtheta ^ 2 * (0.2e1 * ((-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * cos(phd2) ^ 2 + (-0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phd3) ^ 2 + (a(2) ^ 2 + Iota(xx3) - 0.2e1 * l(c3z) * a(2) * sin(phd3) + l(c3z) ^ 2 - Iota(zz3)) * sin(phd2) + a(1) * (a(2) - l(c3z) * sin(phd3))) * cos(phd2) - (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3)) - m(3) * l(c3z) * a(2) * cos(phd3) * dphd3 * h_v ^ 2 * dphd2 - m(3) * l(c3z) * a(2) * cos(phd3) * (Dy3 + dphd3 * Dtheta + Dy2 + dphd2 * Dtheta) * dphd3 * h_v - (sin(phd2) * l(c2x) + cos(phd2) * l(c2y) - a(2) * sin(phd2)) * m(2) * gravity - (l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) - a(2) * sin(phd2)) * m(3) * gravity m(3) * (-l(c3z) * a(2) * sin(phd3) + Iota(yy3) + l(c3z) ^ 2) * (ddphd2 * h_v ^ 2 + dphd2 * h_a) + m(3) * (Iota(yy3) + l(c3z) ^ 2) * (ddphd3 * h_v ^ 2 + dphd3 * h_a) + m(3) * (-((-0.2e1 * l(c3z) ^ 2 - 0.2e1 * Iota(xx3) + 0.2e1 * Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3) * cos(phd2) ^ 2 + (0.2e1 * sin(phd2) * (l(c3z) ^ 2 + Iota(xx3) - Iota(zz3)) * cos(phd3) ^ 2 + (l(c3z) * a(2) * sin(phd3) + Iota(zz3) - Iota(xx3) - l(c3z) ^ 2) * sin(phd2) + l(c3z) * sin(phd3) * a(1)) * cos(phd2) + (l(c3z) * sin(phd2) * a(1) + (-l(c3z) ^ 2 - Iota(xx3) + Iota(zz3)) * sin(phd3) + l(c3z) * a(2)) * cos(phd3)) * dphd1 ^ 2 * Dtheta ^ 2 + m(3) * l(c3z) * a(2) * cos(phd3) * dphd2 ^ 2 * h_v ^ 2 - l(c3z) * (sin(phd2) * sin(phd3) - cos(phd2) * cos(phd3)) * m(3) * gravity]';

u = U+v;

% taumax = [10,300,500]';
% taumin = [-10,-300, -500]';
% 
% u = min(u, taumax);
% u = max(u, taumin);
end